// IBFVDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IBFV2D.h"
#include "IBFVDlg.h"
#include ".\ibfvdlg.h"
#include <conio.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//#include "VField.h"

#include "MorseDecomp.h"
#include "EvenStreamlines.h"

#include "BmpProcess.h"

extern Polyhedron *object;
extern MorseDecomp *morse_decomp;

extern ECG_Graph *ecg;


/*For performance*/
extern time_t g_rawtime;
extern clock_t g_start, g_finish;

extern HDC g_hDC;
extern PeriodicOrbitList *periodic_orbits;
extern MCG_Graph *mcg;
extern	EvenStreamlinePlace *evenplace;
extern TrajectoryList *separatrices;

extern int ndisplay_trajs;
extern int ndisplay_POs;


CListBox *g_ctrlDebugList;
HANDLE	thread;
CGlView *g_pclGlView;
CGraphView *g_pCgraphView;
CButton *g_ctrlShowMCG;
CButton *g_ctrlShowSep;
CButton *g_ctrlButtonDetectFixedPts;
CButton *g_ctrlButtonCalSeps;
CButton *g_ctrlButtonExtracPOs;
CButton *g_ctrlButtonMorseDecomp;
CButton *g_ctrlButtonBrowsePLYFile;
CButton *g_ctrlEnhancedStreamlinesPlace;
CButton *g_ctrlButtonStreamlineLoad;
CString SetStreamlinefiletoSave;
bool save_streamlines_tofile = false;

CString obj_filename;  /*the global file name of the currently being loaded object*/



/*variables related to the interface*/
int DebugOn;  //show all the debug information

const int win_height=800;
const int win_width=800;

 double g_zoom_factor = 1.0;

extern double SCALE;
extern int npn;
extern int npix;
extern double  tmax;
extern double  dmax;
extern double  singsize;
extern double trans_x;
extern double trans_y;

extern double StreamlinePlace_slength;
extern double StreamlinePlace_dsep;


extern int picked_node;                  ////The picked up node when mouse moves to it

extern double edge_sample_error;
extern bool EnConleyIndexComp; 
extern bool RemRedundantMCGEdges ;
extern bool  EnGreyTexture;
extern bool NotShiny;
extern bool DisableLighting;
extern bool DisableBackground;
extern bool EnTubeLikeVis;

extern bool ShowTDistribution;
extern bool ShowDiffECGMCG;
extern bool ShowMCGDiff;

extern bool ShowRotSumOn;

bool RemoveDisconnMSOn = false;

bool noTmax = false;

int Integrator_opt = 0;

extern MorseDecomp *L1_morse;
extern MorseDecomp *L2_morse;


extern void output_MS(char *filename, MCG_Graph *mcg, MorseDecomp *md);


void ScreenToSecondWin(
   int px, int py,
   int screen_leftx, int screen_bottomy,
   int win_screen_sizex, int win_screen_sizey,
   double world_leftx, double world_bottomy,
   double win_world_sizex, double win_world_sizey,
   double &s, double &t)
{
	double ratiox = (double)(px - screen_leftx) / (double)win_screen_sizex;
	double ratioy = (double)(screen_bottomy - py)/(double)win_screen_sizey;
    
	s = (double)world_leftx + ratiox * win_world_sizex;
	t = (double)world_bottomy + ratioy * win_world_sizey;
}


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CIBFVDlg dialog



CIBFVDlg::CIBFVDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIBFVDlg::IDD, pParent)
	, m_edLoadPlyFile(_T(""))
	, m_edLoadStreamlineResutls(_T(""))
	, m_edSetStreamlinefiletoSave(_T(""))
	, m_chkSaveStreamlineResults(FALSE)
	, m_chkMoveorNot(FALSE)
	, m_chkDebugOn(FALSE)
	, m_chkEnhancedStreamlinePlacementOn(FALSE)
	, m_chkShowMCG(FALSE)
	, m_chkShowMorseSets(FALSE)
	, m_chkShowPeriodicOrbitsOn(FALSE)
	, m_chkShowSepsOn(FALSE)
	, m_chkShowFixedPtsOn(FALSE)
	, m_edStreamlinePlace_dsep(0.03)
	, m_edStreamlinePlace_slength(0.03)
	, m_chkColorVFMagOn(FALSE)
	, m_edTau(0)
	, local_morse(0)
	, local_tau(0)
	, min_pri(0)
	, tau_max(0)
	, iter_max(0)
	, ini_tau(0)
	, regiontau(NULL)
	, Morse_Connection(0)
	, Triangle_Connection(0)
	, SampleVis(FALSE)
	, m_chkShowTriMappingOn(FALSE)
	, SampleBackward(FALSE)
	, sampling_edge(0)
	, ShowRegion(FALSE)
	, ShowBoundary(TRUE)
	, ShowConleyMCG(FALSE)
	, ComputeRegion(FALSE)
	, mnode1(0)
	, mnode2(0)
	, m_edEdgeSampleError(1e-15)
	, m_chkEnFastRefinement(FALSE)
	, Conn_tau(0)
	, m_chkEnConleyIndexComp(TRUE)
	, m_chkRemRedundantMCGEdges(FALSE)
	, m_chkEnGreyTexture(FALSE)
	, m_chkNotShiny(FALSE)
	, m_chkDisableLighting(FALSE)
	, m_chkDisableBackground(FALSE)
	, m_chkEnTubeLikeVis(FALSE)
	, m_chkShowTDistribution(FALSE)
	, m_chkShowDiffECGMCG(FALSE)
	, m_chkShowMCGDiff(FALSE)
	, m_chkNoTMax(FALSE)
	, m_rdIntegrator_opt(FALSE)
	, m_chkRemoveDisconnMSOn(FALSE)
	, m_chkFlipNormalOn(FALSE)
	, m_chkIBFVOff(FALSE)
	, m_chkShowRotSumOn(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	g_ctrlDebugList = &m_ctrlDebugList;

	m_chkDebugOn = TRUE;
	DebugOn = 1;

	g_ctrlShowMCG = &m_ctrlShowMCG;
	g_ctrlShowSep = &m_ctrlShowSep;
	g_ctrlButtonDetectFixedPts = &m_ctrlButtonDetectFixedPts;
	g_ctrlButtonCalSeps = &m_ctrlButtonCalSeps;
	g_ctrlButtonExtracPOs = &m_ctrlButtonExtracPOs;
	g_ctrlButtonMorseDecomp = &m_ctrlButtonMorseDecomp;

	g_ctrlButtonBrowsePLYFile = &m_ctrlButtonBrowsePLYFile;
	g_ctrlEnhancedStreamlinesPlace = &m_ctrlEnhancedStreamlinesPlace;

	g_ctrlButtonStreamlineLoad = &m_ctrlButtonStreamlineLoad;

	StreamlinePlace_slength = 0.03;
    StreamlinePlace_dsep = 0.03;

	m_edSetStreamlinefiletoSave += "streamlines.txt"; /*set to the object file name + _streamlines*/

	regiontau = new RegionTauMap();

}

	
void CIBFVDlg::restore_init_state()
{
	m_chkSaveStreamlineResults = FALSE;
	m_chkMoveorNot = FALSE;
	m_chkDebugOn = TRUE;
	m_chkEnhancedStreamlinePlacementOn = FALSE;
	m_chkShowMCG = FALSE;
	m_chkShowMorseSets = FALSE;
	m_chkShowPeriodicOrbitsOn = FALSE;
	m_chkShowSepsOn = FALSE;
	m_chkShowFixedPtsOn = FALSE;
	m_edStreamlinePlace_dsep = 0.03;
	m_edStreamlinePlace_slength = 0.03;

	m_ctrlDebugList.ResetContent();

	//int lines = m_ctrlDebugList.GetCount();
	//for(int i=0; i<lines; i++)
	//	m_ctrlDebugList.DeleteString(i);
}


void CIBFVDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_PLYFILE, m_edLoadPlyFile);
	DDX_Text(pDX, IDC_EDIT3, m_edLoadStreamlineResutls);
	DDX_Text(pDX, IDC_EDIT_SAVESTREAMLINEFILE, m_edSetStreamlinefiletoSave);
	DDX_Check(pDX, IDC_CHECK9_SAVESTREAMLINERESULTS, m_chkSaveStreamlineResults);
	DDX_Check(pDX, IDC_CHECK_ANIMATETEXTURE, m_chkMoveorNot);
	DDX_Check(pDX, IDC_CHECK_DEBUGON, m_chkDebugOn);
	DDX_Control(pDX, IDC_LIST_DEBUGLIST, m_ctrlDebugList);
	DDX_Check(pDX, IDC_CHECK_ENHANCEDMETON, m_chkEnhancedStreamlinePlacementOn);
	DDX_Check(pDX, IDC_CHECK_SHOWMCGON, m_chkShowMCG);
	DDX_Check(pDX, IDC_CHECK_SHOWMORSESETS, m_chkShowMorseSets);
	DDX_Check(pDX, IDC_CHECK_SHOWPERIODICORBITS, m_chkShowPeriodicOrbitsOn);
	DDX_Check(pDX, IDC_CHECK_SHOWSEPS, m_chkShowSepsOn);
	DDX_Check(pDX, IDC_CHECK_SHOWFIXEDPTS, m_chkShowFixedPtsOn);
	DDX_Text(pDX, IDC_EDIT_STREAMLINESEPARATE, m_edStreamlinePlace_dsep);
	DDX_Text(pDX, IDC_EDIT_STREAMLINELENGTH, m_edStreamlinePlace_slength);
	DDX_Control(pDX, IDC_CHECK_SHOWMCGON, m_ctrlShowMCG);
	DDX_Control(pDX, IDC_CHECK_SHOWSEPS, m_ctrlShowSep);
	DDX_Control(pDX, IDC_BUTTON_FIXEDPTDETECT, m_ctrlButtonDetectFixedPts);
	DDX_Control(pDX, IDC_BUTTON_CALSEPS, m_ctrlButtonCalSeps);
	DDX_Control(pDX, IDC_BUTTON_EXTRACTPERIODICORBITS, m_ctrlButtonExtracPOs);
	DDX_Control(pDX, IDC_BUTTON_MORSEDECOMP, m_ctrlButtonMorseDecomp);
	DDX_Control(pDX, IDC_BUTTON_FILEBORROWS, m_ctrlButtonBrowsePLYFile);
	DDX_Control(pDX, IDC_CHECK_ENHANCEDMETON, m_ctrlEnhancedStreamlinesPlace);
	DDX_Control(pDX, IDC_BUTTON_BORROWSTREAMLINEFILE, m_ctrlButtonStreamlineLoad);
	DDX_Check(pDX, IDC_CHECK_SHOWVFMAGNITUDE, m_chkColorVFMagOn);
	DDX_Text(pDX, IDC_EDIT_TAUVALUE, m_edTau);
	DDX_Control(pDX, IDC_OPENGLWIN, m_ctrlOpenGlWin);
	DDX_Text(pDX, IDC_EDIT2, local_morse);
	DDX_Text(pDX, IDC_EDIT4, local_tau);
	DDX_Text(pDX, IDC_EDIT5, min_pri);
	DDX_Text(pDX, IDC_EDIT6, tau_max);
	DDX_Text(pDX, IDC_EDIT7, iter_max);
	DDX_Text(pDX, IDC_EDIT8, ini_tau);
	DDX_Control(pDX, IDC_CGRAPHWIN, m_ctrlConnectGraphWin);
	DDX_Check(pDX, IDC_SHOWREALID, m_chkShowRealMorseID);
	DDX_Text(pDX, IDC_EDIT9, Morse_Connection);
	DDX_Text(pDX, IDC_EDIT10, Triangle_Connection);
	DDX_Check(pDX, IDC_Sample_Vis, SampleVis);
	DDX_Check(pDX, IDC_CHECK_SHOWTRIMAPPING, m_chkShowTriMappingOn);
	DDX_Check(pDX, IDC_ShowBackward, SampleBackward);
	DDX_Check(pDX, IDC_CHECK_Show_Region, ShowRegion);
	DDX_Check(pDX, IDC_CHECK_ShowBoundary, ShowBoundary);
	DDX_Check(pDX, IDC_ShowConleyMCG, ShowConleyMCG);
	DDX_Check(pDX, IDC_CHECK_Compute_Connection_Region, ComputeRegion);
	DDX_Text(pDX, IDC_EDIT1_MORSESET1, mnode1);
	DDX_Text(pDX, IDC_EDIT_MORSESET2, mnode2);
	DDX_Text(pDX, IDC_EDIT_SAMPLEERROR, m_edEdgeSampleError);
	DDX_Check(pDX, IDC_CHECK_ENFASTREFINE, m_chkEnFastRefinement);
	DDX_Text(pDX, IDC_EDIT11, Conn_tau);
	DDX_Check(pDX, IDC_CHECK_ENCONLEYINDEXCOMP, m_chkEnConleyIndexComp);
	DDX_Check(pDX, IDC_CHECK_REMOVEREDUNDANTEDGES, m_chkRemRedundantMCGEdges);
	DDX_Check(pDX, IDC_CHECK_GREYTEXTURE, m_chkEnGreyTexture);
	DDX_Check(pDX, IDC_CHECK_NOSHINY, m_chkNotShiny);
	DDX_Check(pDX, IDC_CHECK_DISABLELIGHTING, m_chkDisableLighting);
	DDX_Check(pDX, IDC_CHECK_DISABLEBACKGROUND, m_chkDisableBackground);
	DDX_Check(pDX, IDC_CHECK_SHOWTUBELIKE, m_chkEnTubeLikeVis);
	DDX_Check(pDX, IDC_CHECK_SHOWTAUDISTRIBUTION, m_chkShowTDistribution);
	DDX_Check(pDX, IDC_CHECK_DISPLAYDIFFECGMCG, m_chkShowDiffECGMCG);
	DDX_Check(pDX, IDC_CHECK_SHOWDIFFMCGS, m_chkShowMCGDiff);
	DDX_Check(pDX, IDC_CHECK_AUTOSTOP, m_chkNoTMax);
	DDX_Radio(pDX, IDC_RADIO_EULER1, m_rdIntegrator_opt);
	DDX_Check(pDX, IDC_CHECK_REMOVEDISCONN, m_chkRemoveDisconnMSOn);
	DDX_Check(pDX, IDC_CHECK_FLIPNORMAL, m_chkFlipNormalOn);
	DDX_Check(pDX, IDC_CHECK_DISABLE_IBFV, m_chkIBFVOff);
	DDX_Check(pDX, IDC_CHECK_SHOWROTATIONSUM, m_chkShowRotSumOn);
}

BEGIN_MESSAGE_MAP(CIBFVDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_BUTTON_FILEBORROWS, OnBnClickedButtonFileborrows)
	ON_BN_CLICKED(IDC_BUTTON_BORROWSTREAMLINEFILE, OnBnClickedButtonBorrowstreamlinefile)
	ON_BN_CLICKED(IDC_CHECK9_SAVESTREAMLINERESULTS, OnBnClickedCheck9Savestreamlineresults)
	ON_BN_CLICKED(IDC_CHECK_ANIMATETEXTURE, OnBnClickedCheckAnimatetexture)
	ON_BN_CLICKED(IDC_CHECK_DEBUGON, OnBnClickedCheckDebugon)
	ON_BN_CLICKED(IDC_CHECK_ENHANCEDMETON, OnBnClickedCheckEnhancedmeton)
	ON_BN_CLICKED(IDC_CHECK_SHOWMCGON, OnBnClickedCheckShowmcgon)
	ON_BN_CLICKED(IDC_CHECK_SHOWMORSESETS, OnBnClickedCheckShowmorsesets)
	ON_BN_CLICKED(IDC_CHECK_SHOWPERIODICORBITS, OnBnClickedCheckShowperiodicorbits)
	ON_BN_CLICKED(IDC_CHECK_SHOWSEPS, OnBnClickedCheckShowseps)
	ON_BN_CLICKED(IDC_CHECK_SHOWFIXEDPTS, OnBnClickedCheckShowfixedpts)
	ON_BN_CLICKED(IDC_BUTTON_FIXEDPTDETECT, OnBnClickedButtonFixedptdetect)
	ON_BN_CLICKED(IDC_BUTTON_PLACESTREAMLINES, OnBnClickedButtonPlacestreamlines)
	ON_BN_CLICKED(IDC_BUTTON_CALSEPS, OnBnClickedButtonCalseps)
	ON_BN_CLICKED(IDC_BUTTON_EXTRACTPERIODICORBITS, OnBnClickedButtonExtractperiodicorbits)
	ON_BN_CLICKED(IDC_BUTTON_MORSEDECOMP, OnBnClickedButtonMorsedecomp)
	ON_BN_CLICKED(IDC_BUTTON_SAVEBMPIMG, OnBnClickedButtonSavebmpimg)
	ON_BN_CLICKED(IDC_CHECK_SHOWVFMAGNITUDE, OnBnClickedCheckShowvfmagnitude)
	ON_BN_CLICKED(IDC_BUTTON_SETTAU, OnBnClickedButtonSettau)
	ON_WM_MOUSEWHEEL()
	ON_WM_MBUTTONDOWN()
	ON_WM_MBUTTONUP()
	ON_BN_CLICKED(IDC_EXROT, &CIBFVDlg::OnBnClickedExrot)
	ON_BN_CLICKED(IDC_INROT, &CIBFVDlg::OnBnClickedInrot)
	ON_EN_CHANGE(IDC_EDIT2, &CIBFVDlg::OnEnChangeEdit2)
	ON_EN_CHANGE(IDC_EDIT4, &CIBFVDlg::OnEnChangeEdit4)
	ON_EN_CHANGE(IDC_EDIT5, &CIBFVDlg::OnEnChangeEdit5)
	ON_EN_CHANGE(IDC_EDIT6, &CIBFVDlg::OnEnChangeEdit6)
	ON_EN_CHANGE(IDC_EDIT7, &CIBFVDlg::OnEnChangeEdit7)
	ON_EN_CHANGE(IDC_EDIT8, &CIBFVDlg::OnEnChangeEdit8)
	ON_BN_CLICKED(IDC_LOCAL_REFINE, &CIBFVDlg::OnBnClickedLocalRefine)
	ON_BN_CLICKED(IDC_AUTO_REFINE, &CIBFVDlg::OnBnClickedAutoRefine)
	ON_BN_CLICKED(IDC_SHOWREALID, &CIBFVDlg::OnBnClickedShowrealid)
	ON_BN_CLICKED(IDC_Display_Morse_Connection, &CIBFVDlg::OnBnClickedDisplayMorseConnection)
	ON_BN_CLICKED(IDC_Display_Triangle_Connection, &CIBFVDlg::OnBnClickedDisplayTriangleConnection)
	ON_BN_CLICKED(IDC_Display_SCC, &CIBFVDlg::OnBnClickedDisplayScc)
	ON_EN_CHANGE(IDC_EDIT9, &CIBFVDlg::OnEnChangeEdit9)
	ON_EN_CHANGE(IDC_EDIT10, &CIBFVDlg::OnEnChangeEdit10)
	ON_BN_CLICKED(IDC_Sample_Vis, &CIBFVDlg::OnBnClickedSampleVis)
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_BN_CLICKED(IDC_CHECK_SHOWTRIMAPPING, &CIBFVDlg::OnBnClickedCheckShowtrimapping)
	ON_BN_CLICKED(IDC_ShowBackward, &CIBFVDlg::OnBnClickedShowbackward)
	ON_BN_CLICKED(IDC_Change_Edge, &CIBFVDlg::OnBnClickedChangeEdge)
	ON_BN_CLICKED(IDC_CHECK_Show_Region, &CIBFVDlg::OnBnClickedCheckShowRegion)
	ON_BN_CLICKED(IDC_CHECK_ShowBoundary, &CIBFVDlg::OnBnClickedCheckShowboundary)
	ON_BN_CLICKED(IDC_ShowConleyMCG, &CIBFVDlg::OnBnClickedShowconleymcg)
	ON_BN_CLICKED(IDC_CHECK_Compute_Connection_Region, &CIBFVDlg::OnBnClickedCheckComputeConnectionRegion)
	ON_BN_CLICKED(IDC_BUTTON_REFINEMCGEDGE, &CIBFVDlg::OnBnClickedButtonRefinemcgedge)
	ON_BN_CLICKED(IDC_BUTTON_REFINECONNREG, &CIBFVDlg::OnBnClickedButtonRefineconnreg)
	ON_EN_CHANGE(IDC_EDIT1_MORSESET1, &CIBFVDlg::OnEnChangeEdit1Morseset1)
	ON_EN_CHANGE(IDC_EDIT_MORSESET2, &CIBFVDlg::OnEnChangeEditMorseset2)
	ON_EN_CHANGE(IDC_EDIT_TAUVALUE, &CIBFVDlg::OnEnChangeEditTauvalue)
	ON_EN_CHANGE(IDC_EDIT_SAMPLEERROR, &CIBFVDlg::OnEnChangeEditSampleerror)
	ON_BN_CLICKED(IDC_CHECK_ENFASTREFINE, &CIBFVDlg::OnBnClickedCheckEnfastrefine)
	ON_EN_CHANGE(IDC_EDIT11, &CIBFVDlg::OnEnChangeEdit11)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUTDIRGRAPH, &CIBFVDlg::OnBnClickedButtonOutputdirgraph)
	ON_BN_CLICKED(IDC_BUTTON_LOADDIRGRAPH, &CIBFVDlg::OnBnClickedButtonLoaddirgraph)
	ON_BN_CLICKED(IDC_CHECK_ENCONLEYINDEXCOMP, &CIBFVDlg::OnBnClickedCheckEnconleyindexcomp)
	ON_BN_CLICKED(IDC_CHECK_REMOVEREDUNDANTEDGES, &CIBFVDlg::OnBnClickedCheckRemoveredundantedges)
	ON_BN_CLICKED(IDC_CHECK_GREYTEXTURE, &CIBFVDlg::OnBnClickedCheckGreytexture)
	ON_BN_CLICKED(IDC_CHECK_NOSHINY, &CIBFVDlg::OnBnClickedCheckNoshiny)
	ON_BN_CLICKED(IDC_CHECK_DISABLELIGHTING, &CIBFVDlg::OnBnClickedCheckDisablelighting)
	ON_BN_CLICKED(IDC_CHECK_DISABLEBACKGROUND, &CIBFVDlg::OnBnClickedCheckDisablebackground)
	ON_BN_CLICKED(IDC_CHECK_SHOWTUBELIKE, &CIBFVDlg::OnBnClickedCheckShowtubelike)
	ON_BN_CLICKED(IDC_CHECK_SHOWTAUDISTRIBUTION, &CIBFVDlg::OnBnClickedCheckShowtaudistribution)
	ON_BN_CLICKED(IDC_CHECK_DISPLAYDIFFECGMCG, &CIBFVDlg::OnBnClickedCheckDisplaydiffecgmcg)
	ON_BN_CLICKED(IDC_CHECK_SHOWDIFFMCGS, &CIBFVDlg::OnBnClickedCheckShowdiffmcgs)
	ON_BN_CLICKED(IDC_CHECK_AUTOSTOP, &CIBFVDlg::OnBnClickedCheckAutostop)
	ON_BN_CLICKED(IDC_RADIO_EULER1, &CIBFVDlg::OnBnClickedRadioEuler1)
	ON_BN_CLICKED(IDC_RADIO_RK2, &CIBFVDlg::OnBnClickedRadioRk2)
	ON_BN_CLICKED(IDC_RADIO_RK4, &CIBFVDlg::OnBnClickedRadioRk4)
	ON_BN_CLICKED(IDC_CHECK_REMOVEDISCONN, &CIBFVDlg::OnBnClickedCheckRemovedisconn)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUTSUBGRAPH, &CIBFVDlg::OnBnClickedButtonOutputsubgraph)
	ON_BN_CLICKED(IDC_BUTTON_LOAD1, &CIBFVDlg::OnBnClickedButtonLoad1)
	ON_BN_CLICKED(IDC_BUTTON_l2, &CIBFVDlg::OnBnClickedButtonl2)
	ON_BN_CLICKED(IDC_CHECK_FLIPNORMAL, &CIBFVDlg::OnBnClickedCheckFlipnormal)
	ON_BN_CLICKED(IDC_CHECK_DISABLE_IBFV, &CIBFVDlg::OnBnClickedCheckDisableIbfv)
	ON_BN_CLICKED(IDC_CHECK_SHOWROTATIONSUM, &CIBFVDlg::OnBnClickedCheckShowrotationsum)
	ON_BN_CLICKED(IDC_BUTTON_ROTATIONSUM, &CIBFVDlg::OnBnClickedButtonRotationsum)
	ON_BN_CLICKED(IDC_BUTTON_OUTPUTTRIANGLELABELS, &CIBFVDlg::OnBnClickedButtonOutputtrianglelabels)
	ON_BN_CLICKED(IDC_BUTTON_SUMSMOOTH, &CIBFVDlg::OnBnClickedButtonSumsmooth)
	ON_BN_CLICKED(IDC_BUTTON_SAVEAFIELD, &CIBFVDlg::OnBnClickedButtonSaveafield)
	ON_BN_CLICKED(IDC_BUTTON_LOADAFIELD, &CIBFVDlg::OnBnClickedButtonLoadafield)
END_MESSAGE_MAP()


// CIBFVDlg message handlers

/*should we put separatrices here*/
//extern TrajectoryList *separatrices;

BOOL CIBFVDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CStatic *pclStatic = (CStatic *)GetDlgItem(IDC_OPENGLWIN);
	pclGlView = new CGlView(pclStatic);

	g_pclGlView = pclGlView;

	HDC m_hDC;
    g_hDC = m_hDC = ::GetDC(this->m_hWnd);

    RECT rect;
	//GetClientRect(&rect);
	
	LPPOINT ptSomePoint = &firstwin_leftbottom;
	/*------------------------------------------*/
	////Get the size and position of the window
	m_ctrlOpenGlWin.GetClientRect(&rect);
	firstwin_leftx = rect.left;
	firstwin_rightx = rect.right;
	firstwin_bottomy = rect.bottom;
	firstwin_topy = rect.top;
	
	firstwin_leftbottom.x = rect.left;
	firstwin_leftbottom.y = rect.bottom;

	m_ctrlOpenGlWin.ScreenToClient(ptSomePoint);

	//FILE *this_file = fopen("sphere.ply", "r");
	//FILE *this_file = fopen("torus.ply", "r");
	//FILE *this_file = fopen("coolingJacketSurfaceWithVelocityASCII6.ply", "r");
	//FILE *this_file = fopen("combustionChamberSurfaceWithVelocityASCII2.ply", "r");
	//FILE *this_file = fopen("combustionChamberSurfaceWithVelocityASCII3.ply", "r");
	//FILE *this_file = fopen("intakePortSurfaceWithVelocityASCII3.ply", "r");
	//FILE *this_file = fopen("sphere1.ply", "r");
	//FILE *this_file = fopen("torus1.ply", "r");
	//FILE *this_file = fopen("iceland_current_field.ply", "r");
	//FILE *this_file = fopen("bunny1.ply", "r");
	FILE *this_file = fopen("simple_fld2.ply", "r");
	//FILE *this_file = fopen("earthquake.ply", "r");

	if(this_file == NULL)
		goto LL;

	obj_filename.Format("sphere1");
	
	FILE *fp;
	if(DebugOn == 1)
	{
		fp = fopen("detect_process_log.txt", "w");
		fprintf(fp, "loading object!\n");
		fclose(fp);
	}

	object = new Polyhedron(this_file, 1);

	object->initialize();
	pclGlView->rot_center = object->rot_center;  ////set the rotation center!


	object->cal_TexCoord();

	//object->capture_Singularities();

	//object->cal_separatrices();  //04/17/07

	morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/

	L1_morse = new MorseDecomp();
	L2_morse = new MorseDecomp();

LL:	pclGlView->OnCreate();

	if(DebugOn == 1)
	{
		fp = fopen("detect_process_log.txt", "a");
		if(fp != NULL)
		{
			fprintf(fp, "finish initializing the object!\n");
			fclose(fp);
		}
	}

	/*-------------------------------------------------------*/
	/*--------------extract periodic orbits-----------------*/

	/*comments start from here 06/21/07*/


//	time ( &g_rawtime );
//	g_start = clock();
//
//	//fp = fopen("detect_porbit_cooling.txt", "w");
//	//fp = fopen("detect_porbit_swirl.txt", "w");
//	fp = fopen("detect_porbit_tumble.txt", "w");
//	fprintf(fp, "Starting extracting periodic orbits...\n");
//	fprintf(fp, "current date and time are :  %s. \n", ctime (&g_rawtime) );
//	fclose(fp);
//
//	object->detect_PeriodicOrbit();
//
//    g_finish = clock();
//	time ( &g_rawtime );
//	//fp = fopen("detect_porbit_cooling.txt", "a");
//	//fp = fopen("detect_porbit_swirl.txt", "a");
//	fp = fopen("detect_porbit_tumble.txt", "a");
//	fprintf(fp, "%d periodic orbits have been found...\n", periodic_orbits->nporbits);
//	fprintf(fp, "time for this operation is %f seconds\n",(double)(g_finish - g_start)/CLOCKS_PER_SEC);
//	fprintf(fp, "current date and time are :  %s. \n", ctime (&g_rawtime) );
//	fclose(fp);
//
//	g_start = clock();
//
//
//	/*construct the MCG here*/
	mcg = new MCG_Graph();
	mcg->init_MCG();
//	mcg->build_mcg();
//	
//    g_finish = clock();
//	//fp = fopen("detect_porbit_cooling.txt","a");
//	//fp = fopen("detect_porbit_swirl.txt", "a");
//	fp = fopen("detect_porbit_tumble.txt", "a");
//	fprintf(fp, "number of edges in MCG is :  %d. \n", mcg->elist->nedges);
//	fprintf(fp, "time for MCG construction is %f seconds\n",(double)(g_finish - g_start)/CLOCKS_PER_SEC);
//	fclose(fp);
//
////extern ECG_Graph *ecg;
//	g_start = clock();
	//ecg = new ECG_Graph(object->slist.nsingularities+periodic_orbits->nporbits);
	//ecg->init_ECG();
//	ecg->build_ecg();
//    g_finish = clock();
//	
//	//fp = fopen("detect_porbit_cooling.txt","a");
//	//fp = fopen("detect_porbit_swirl.txt", "a");
//	fp = fopen("detect_porbit_tumble.txt", "a");
//	fprintf(fp, "\nnumber of edges in ECG is :  %d. \n", ecg->elist->nedges);
//	fprintf(fp, "time for ECG construction is %f seconds\n",(double)(g_finish - g_start)/CLOCKS_PER_SEC);
//	fclose(fp);
//
//	/*-------------------------------------------------------*/
//	/*-------------------------------------------------------*/
//	/*-----------------calculate evenly placed streamlines-----------------*/
    //evenplace = new EvenStreamlinePlace();

	//	//evenplace->load_from_a_file("chamber2_evenstreamlines_0.03.txt");
//	//evenplace->load_from_a_file("chamber3_evenstreamlines_0.02.txt");
//	//evenplace->load_from_a_file_enhanced("chamber3_evenstreamlines.txt");
//
//
//	/************************************************************************************/
//	//// even streamline placement testing
//
//    fp = fopen("evenplacement_chamber.txt", "w");
//    //fp = fopen("evenplacement_swirl.txt", "w");
//    //fp = fopen("evenplacement_cooling.txt", "w");
//	fprintf(fp, "Starting streamline placement...\n");
//	fprintf(fp, "current date and time are :  %s. \n", ctime (&g_rawtime) );
//	fclose(fp);
	//evenplace->init();
	//evenplace->reset_placement();
	//evenplace->place_streamlines(0);
//	evenplace->place_streamlines(1);
//
//    g_finish = clock();
//	time ( &g_rawtime );
//	fp = fopen("evenplacement_chamber.txt", "a");
//    //fp = fopen("evenplacement_swirl.txt", "w");
//    //fp = fopen("evenplacement_cooling.txt", "w");
//	fprintf(fp, "%d streamlines have been computed...\n", evenplace->evenstreamlines->ntrajs);
//	fprintf(fp, "time for this operation is %f seconds\n",(double)(g_finish - g_start)/CLOCKS_PER_SEC);
//	fprintf(fp, "current date and time are :  %s. \n", ctime (&g_rawtime) );
//	fclose(fp);
//
//	/*write the result into a file*/
//	//evenplace->save_to_a_file("chamber3_evenstreamlines.txt");
//	//evenplace->save_to_a_file("chamber3_evenstreamlines.txt");
//	//evenplace->save_to_a_file("cooling_evenstreamlines.txt");
//	//evenplace->save_to_a_file("swirl_evenstreamlines.txt");
//
//		evenplace->save_to_a_file("chamber3_evenstreamlines.txt", 1);
//	//evenplace->save_to_a_file("cooling_evenstreamlines.txt", 1);


//
	/************************************************************************************/

	/*10/25/2007*/
	//fp=fopen("planar.txt", "a");
	//fprintf(fp,"finish initializing the object!\n");
	//fclose(fp);


	/*IBFV visualization initialization*/
	pclGlView->makePatterns();
	
	pclGlView->DrawGLScene(GL_RENDER);
	pclGlView->ReCalTexcoord();

	//fp=fopen("planar.txt", "a");
	//fprintf(fp,"finish drawing the object!\n");
	//fclose(fp);

	m_edSetStreamlinefiletoSave = "sphere1_streamline_03.txt";
	UpdateData(FALSE);

	pclStatic = (CStatic *)GetDlgItem(IDC_CGRAPHWIN);
	pCgraphView = new CGraphView(pclStatic);
	
	/*------------------------------------------*/
	////Get the size and position of the window
    ptSomePoint = &secondwin_leftbottom;
	m_ctrlConnectGraphWin.GetClientRect(&rect);
 
	secondwin_leftx = rect.left;
	secondwin_bottomy = rect.bottom;
	secondwin_rightx = rect.right;
	secondwin_topy = rect.top;

	secondwin_leftbottom.x = rect.left;
	secondwin_leftbottom.y = rect.bottom;
	m_ctrlConnectGraphWin.ClientToScreen(ptSomePoint); 

	////correct the error (not a good way)
	secondwin_leftbottom.x -= 4;
	secondwin_leftbottom.y -= 31;


	wglMakeCurrent(pCgraphView->m_hDC, pCgraphView->m_hglRC);
	pCgraphView->OnCreate();
	pCgraphView->InitGL();
	pCgraphView->DrawGLScene(GL_RENDER);

	g_pCgraphView = pCgraphView;

	SetTimer(1,30,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CIBFVDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIBFVDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	
	////Display the object in main window
	wglMakeCurrent(pclGlView->m_hDC, pclGlView->m_hglRC);
	pclGlView->DrawGLScene(GL_RENDER);
	
	////Display the C-graph in the second window
	wglMakeCurrent(pCgraphView->m_hDC, pCgraphView->m_hglRC);
	pCgraphView->DrawGLScene(GL_RENDER);
	
	wglMakeCurrent(pclGlView->m_hDC, pclGlView->m_hglRC);
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIBFVDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CIBFVDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnTimer(nIDEvent);
	OnPaint();
}

void CIBFVDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
}

void CIBFVDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	float r[4];
	double xsize, ysize, s, t, dx, dy;

	/*   check to see whether the cursor falls in the second window  */
	////test whether the mouse's cursor falls in the second window
    wglMakeCurrent(pCgraphView->m_hDC, pCgraphView->m_hglRC);

	if((point.x >= secondwin_leftx+secondwin_leftbottom.x)
		&&(point.x < secondwin_rightx+secondwin_leftbottom.x)
		&&(point.y <= secondwin_leftbottom.y)
		&&(point.y >= secondwin_leftbottom.y - secondwin_bottomy))
	{

		ScreenToSecondWin(point.x, point.y, secondwin_leftbottom.x, secondwin_leftbottom.y,
			secondwin_rightx, secondwin_bottomy, 0, 0, 4, 2, s, t);
		if((s < 0) || (s > 4) || (t < 0) || (t > 2))
		{
			return;
		}

		else{
			int old_picked = picked_node;
			pCgraphView->HitProcessforGraph(s, t);
			//pCgraphView->GetTheHighLightNodeandEdges();

			////We also need to get the highlight of the separatrices and singularities
			////We just need to add some marking on those singularities and the 
			////corresponding saddles (then we can find the separatrices from them easily)
			//pCgraphView->GetHighLightSeparatrices();

			/*we allow user to re-deploy the graph here 03/11/07*/
			if(m_LeftButtonDown == TRUE)
			{
				if(picked_node < 0)
					picked_node = old_picked;

				dx = s-s2_old;
				dy = t-t2_old;
				if(picked_node >= 0)
				{
					if(m_chkShowMCG == TRUE)/*move MCG*/
					{
						mcg->nlist->mnodes[picked_node]->pos.entry[0] += dx;
						mcg->nlist->mnodes[picked_node]->pos.entry[1] += dy;
					}
					else /*move ECG*/
					{
						ecg->nlist->enodes[picked_node]->pos.entry[0] += dx;
						ecg->nlist->enodes[picked_node]->pos.entry[1] += dy;
					}
				}
			}
			s2_old = s;
			t2_old = t;
		}

		return;
	}

	if(m_LeftButtonDown == TRUE){	

	    xsize = (float) win_width;
		ysize = (float) win_height;
	
		s = (2.0 * point.x - win_width) / win_width;
		t = (2.0 * (win_height - point.y) - win_height) / win_height;

		if ((s == s_old) && (t == t_old))
			return;

		traceball.mat_to_quat( pclGlView->rotmat, rvec );
		traceball.trackball( r, s_old, t_old, s, t );
		traceball.add_quats( r, rvec, rvec );
		traceball.quat_to_mat( rvec, pclGlView->rotmat );
	
		s_old = s;
		t_old = t;
	
		OnPaint();

	}
	else if(m_MiddleButtonDown == TRUE) /*IT IS TRANSLATION*/
	{	
			//dx=(dx-.5-trans_x)/zoom_factor+.5;
			//dy=(dy-.5-trans_y)/zoom_factor+.5;
		//trans_x += pan_dx;
		//trans_y += pan_dy;
		double position[3];

		ScreenToSecondWin(point.x, point.y, firstwin_leftbottom.x, firstwin_leftbottom.y,
						firstwin_rightx, firstwin_bottomy, 0, 0, 1, 1, position[0], position[1]);
		s = position[0];
		t = position[1];

		if (fabs(s - s_old)<1.e-7 && fabs(t - t_old)<1.e-7)
			return;

		double dx = s-s_old;
		double dy = t-t_old;

		trans_x += dx;
		trans_y += dy;

		s_old = s;
		t_old = t;

	}
	CDialog::OnMouseMove(nFlags, point);
	wglMakeCurrent(pclGlView->m_hDC, pclGlView->m_hglRC);
	pclGlView->DrawGLScene(GL_RENDER);
}

void CIBFVDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
    m_LeftButtonDown = TRUE;

	double xsize = (double) win_width;
	double ysize = (double) win_height;

	double s = (2.0 * point.x - win_width) / win_width;
    double t = (2.0 * (win_height - point.y) - win_height) / win_height;

	s_old = s;
	t_old = t;

	last_x = point.x;
	last_y = point.y;

	CDialog::OnLButtonDblClk(nFlags, point);

	CDialog::OnLButtonDown(nFlags, point);
}

void CIBFVDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
    m_LeftButtonDown = FALSE;

	pclGlView->ReCalTexcoord();

	CDialog::OnLButtonUp(nFlags, point);

	OnPaint();
}

/*load a new .ply file!*/
void CIBFVDlg::OnBnClickedButtonFileborrows()
{
	// TODO: Add your control notification handler code here

	//load the ply file

	CFile f;

	char strFilter[] = { "Text Files (*.ply)|*.ply|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".ply", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f1 = FileDlg.GetPathName();
		CString f2 = FileDlg.GetFileName();
		CString f4 = f2.Right(f2.GetLength()-f2.ReverseFind('.'));
		CString txt = ".ply";
		if(f4!=txt)
		{
			MessageBox("Not a compatible file format, please select a .ply file", "Error");
			return;
		}
		CString f3 = f2.Left(f2.ReverseFind('.'))+".ply";

		const char *filename = f3;

		m_edLoadStreamlineResutls = f1;


		/*we need to first release the old model*/
		if( object!= NULL)
			delete object;

		/*need to reset all the flags here*/
		pclGlView->init_flags();
		restore_init_state();
	
		/*load the new model*/
		FILE *this_file = fopen(filename, "r");

		if(this_file == NULL)
			return;
		
		FILE *fp;
		if(DebugOn == 1)
		{
			fp = fopen("detect_process_log.txt", "w");
			fprintf(fp, "loading object!\n");
			fclose(fp);
		}

		object = new Polyhedron(this_file, 1);
		obj_filename.Format(f2.Left(f2.ReverseFind('.')));

		object->initialize();
		pclGlView->rot_center = object->rot_center;  ////set the rotation center!



		object->cal_TexCoord();

		//morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/

		//pclGlView->OnCreate();

		if(DebugOn == 1)
		{
			fp = fopen("detect_process_log.txt", "a");
			if(fp != NULL)
			{
				fprintf(fp, "finish initializing the object!\n");
				fclose(fp);
			}
		}

		//mcg = new MCG_Graph();
		//mcg->init_MCG();
		///*IBFV visualization initialization*/
		//pclGlView->makePatterns();
		//
		//pclGlView->DrawGLScene(GL_RENDER);
		pclGlView->ReCalTexcoord();

		/*update the file name for streamline record*/
		UpdateData(TRUE);
		CString temp_num;
		temp_num.Format("%4.3f", m_edStreamlinePlace_dsep);
		m_edSetStreamlinefiletoSave = f2.Left(f2.ReverseFind('.'))+"_streamline_"
			+temp_num.Right(temp_num.GetLength()-temp_num.ReverseFind('.')-1)+".txt";
		
		m_edLoadStreamlineResutls = f1;

	}

	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedButtonBorrowstreamlinefile()
{
	// TODO: Add your control notification handler code here

	//load the results of the previous streamline placement

	CFile f;

	char strFilter[] = { "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".txt", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f1 = FileDlg.GetPathName();
		CString f2 = FileDlg.GetFileName();
		CString f4 = f2.Right(f2.GetLength()-f2.ReverseFind('.'));
		CString txt = ".txt";
		if(f4!=txt)
		{
			MessageBox("Not a compatible file format, please select a .txt file", "Error");
			return;
		}
		CString f3 = f2.Left(f2.ReverseFind('.'))+".txt";

		const char *filename = f3;

		m_edLoadStreamlineResutls = f1;

		/*load the previous results*/

		if(evenplace == NULL)
			evenplace = new EvenStreamlinePlace();

		if(m_chkEnhancedStreamlinePlacementOn == FALSE)
			evenplace->load_from_a_file(filename);
		else
			evenplace->load_from_a_file_enhanced(filename);
	
		pclGlView->EvenStreamlinePlacement = 1;
		
		extern int ndisplay_trajs;
		ndisplay_trajs = evenplace->evenstreamlines->ntrajs;
	}

	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheck9Savestreamlineresults()
{
	// TODO: Add your control notification handler code here
	//UpdateData(TRUE);
	//m_edSetStreamlinefiletoSave += "_streamlines.txt"; /*set to the object file name + _streamlines*/

	if(m_chkSaveStreamlineResults == FALSE)
	{
		m_chkSaveStreamlineResults = TRUE;
		save_streamlines_tofile = true;
	}
	else
	{
		m_chkSaveStreamlineResults = FALSE;
		save_streamlines_tofile = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckAnimatetexture()
{
	// TODO: Add your control notification handler code here
	if(m_chkMoveorNot == FALSE)
	{
		m_chkMoveorNot = TRUE;
		pclGlView->MoveOrStop = 1;
	}
	else
	{
		m_chkMoveorNot = FALSE;
		pclGlView->MoveOrStop = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckDebugon()
{
	// TODO: Add your control notification handler code here
	if(m_chkDebugOn == FALSE)
	{
		m_chkDebugOn = TRUE;
		m_ctrlDebugList.EnableActiveAccessibility();
		DebugOn = 1;
	}
	else
	{
		m_chkDebugOn = FALSE;
		DebugOn = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckEnhancedmeton()
{
	// TODO: Add your control notification handler code here
	if(m_chkEnhancedStreamlinePlacementOn == FALSE)
	{
		m_chkEnhancedStreamlinePlacementOn = TRUE;
	}
	else
	{
		m_chkEnhancedStreamlinePlacementOn = FALSE;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowmcgon()
{
	// TODO: Add your control notification handler code here
	if(m_chkShowMCG == FALSE)
	{
		m_chkShowMCG = TRUE;
		pCgraphView->ShowMCGOn = 1;
	}
	else
	{
		m_chkShowMCG = FALSE;
		pCgraphView->ShowMCGOn = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowmorsesets()
{
	// TODO: Add your control notification handler code here
	if(m_chkShowMorseSets == FALSE)
	{
		m_chkShowMorseSets = TRUE;
		pclGlView->ShowSCCsOn = 1;
	}
	else
	{
		m_chkShowMorseSets = FALSE;
		pclGlView->ShowSCCsOn = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowperiodicorbits()
{
	// TODO: Add your control notification handler code here
	if(m_chkShowPeriodicOrbitsOn == FALSE)
	{
		m_chkShowPeriodicOrbitsOn = TRUE;
		pclGlView->ShowPeriodicOrbitsOn = 1;
	}
	else
	{
		m_chkShowPeriodicOrbitsOn = FALSE;
		pclGlView->ShowPeriodicOrbitsOn = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowseps()
{
	// TODO: Add your control notification handler code here
	if(m_chkShowSepsOn == FALSE)
	{
		m_chkShowSepsOn = TRUE;
		pclGlView->ShowSeparatricesOn = 1;
	}
	else
	{
		m_chkShowSepsOn = FALSE;
		pclGlView->ShowSeparatricesOn = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowfixedpts()
{
	// TODO: Add your control notification handler code here
	if(m_chkShowFixedPtsOn == FALSE)
	{
		m_chkShowFixedPtsOn = TRUE;
		pclGlView->ShowFixedPtOn = 1;
	}
	else
	{
		m_chkShowFixedPtsOn = FALSE;
		pclGlView->ShowFixedPtOn = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedButtonFixedptdetect()
{
	// TODO: Add your control notification handler code here

	//fixed point detection
	m_chkShowFixedPtsOn = TRUE;
	pclGlView->ShowFixedPtOn = 1;

	CString str;
	int loc;
	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start detecting fixed points...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}

	object->capture_Singularities();
	
	if(m_chkDebugOn == TRUE)
	{
		g_finish = clock();
		str.Format(_T("Finish detecting fixed points...\n"));
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format(_T("%d fixed points have been detected\n"), object->slist.nsingularities);
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format(_T("time for this operation is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}

	UpdateData(FALSE);
}


void cal_sep()
{
	if(object->slist.nsingularities == 0)
		object->capture_Singularities();
	g_pclGlView->ShowFixedPtOn = 1;

	object->cal_separatrices();  
	g_pclGlView->ShowSeparatricesOn = 1;

	CString str;
	int loc;
	
	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("%d separatrices have been computed.\n"), separatrices->ntrajs);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for this operation is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}

	g_ctrlShowSep->EnableWindow(TRUE);

	/*construct the ECG here!*/
	g_start = clock();

	if(ecg!=NULL)
		delete ecg;

	if(periodic_orbits == NULL)
		ecg = new ECG_Graph(object->slist.nsingularities);
	else
		ecg = new ECG_Graph(object->slist.nsingularities+periodic_orbits->nporbits);
	ecg->init_ECG();
	ecg->build_ecg();

	g_pCgraphView->ShowMCGOn = 0;
	g_ctrlShowMCG->EnableWindow(TRUE);

	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("%d nodes and %d edges of ECG have been computed.\n"), ecg->nlist->nenodes,
			ecg->elist->nedges);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for constructing the ECG is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}
	
	g_ctrlButtonCalSeps->EnableWindow(TRUE);            //enable separatrix calculation
	g_ctrlButtonExtracPOs->EnableWindow(TRUE);          //enable periodic orbit extraction
	g_ctrlButtonBrowsePLYFile->EnableWindow(TRUE);      //enable loading the new ply file
	g_ctrlEnhancedStreamlinesPlace->EnableWindow(TRUE); //enable enhanced streamline placement
}


void CIBFVDlg::OnBnClickedButtonCalseps()
{
	// TODO: Add your control notification handler code here

	/*compute the separatrices*/
	m_chkShowSepsOn = TRUE;
	pclGlView->ShowSeparatricesOn = 0;
	m_chkShowMCG = FALSE;  //show ECG only under this mode
	m_chkShowFixedPtsOn = TRUE;
	UpdateData(FALSE);
	m_ctrlShowSep.EnableWindow(FALSE);
	m_ctrlShowMCG.EnableWindow(FALSE);  //don't allow user to modify the displaying mode

	m_ctrlButtonCalSeps.EnableWindow(FALSE);            //disable separatrix calculation
	m_ctrlButtonExtracPOs.EnableWindow(FALSE);          //disable periodic orbit extraction
	m_ctrlButtonBrowsePLYFile.EnableWindow(FALSE);      //disable loading the new ply file
	m_ctrlEnhancedStreamlinesPlace.EnableWindow(FALSE); //disable enhanced streamline placement
	
	//pCgraphView->ShowMCGOn = 1;
	
	CString str;
	int loc;
	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start computing the separatrices...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}
	
	//Create a multiple thread to run it
	DWORD threadID;
	thread = CreateThread(NULL,
		0,
		(LPTHREAD_START_ROUTINE) cal_sep,
		NULL,
		CREATE_SUSPENDED,
		&threadID);

	if(thread == NULL)
	{
		MessageBox("Creating thread failed!", "Error");
		return;
	}

	if(!SetThreadPriority(thread, THREAD_PRIORITY_NORMAL))
	{
		MessageBox("Seting priority of the thread failed!", "Error");
		return;
	}

	if((ResumeThread(thread)) == -1)
	{
		MessageBox("Resuming thread failed!", "Error");
		return;
	}
}



/*the global function for extracting periodic orbits*/
void extract_periodicorbits()
{
	CString str;
	int loc;
	FILE *fp;

	if(object->slist.nsingularities == 0)
		object->capture_Singularities();
	g_pclGlView->ShowFixedPtOn = 1;

	object->detect_PeriodicOrbit();
	g_pclGlView->ShowPeriodicOrbitsOn = 1;

	ndisplay_POs = periodic_orbits->nporbits;

	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("%d periodic orbits have been detected.\n"), periodic_orbits->nporbits);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for this operation is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}


	/*construct ECG and MCG here*/
	g_start = clock();
	
	if(mcg != NULL)
		delete mcg;

	mcg = new MCG_Graph();
	mcg->init_MCG();
	mcg->build_mcg();
	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("%d nodes and %d edges of MCG have been computed.\n"), mcg->nlist->nmnodes,
			mcg->elist->nedges);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for constructing the MCG is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		//str.Format("--------------------------------------");
		//loc=g_ctrlDebugList->GetCount();
		//g_ctrlDebugList->InsertString(loc, str);
	}

	g_pCgraphView->ShowMCGOn = 1;

	g_start = clock();
	g_pclGlView->ShowSeparatricesOn = 0;
	object->cal_separatrices(); /*calculate the separatrice for ECG*/
	g_pclGlView->ShowSeparatricesOn = 1;
	if(DebugOn == 1)
	{
		fp = fopen("detect_process_log.txt", "a");
		fprintf(fp, "finish calculating separatrices!\n");
		fclose(fp);
	}

	if(ecg!=NULL)
		delete ecg;

	ecg = new ECG_Graph(object->slist.nsingularities+periodic_orbits->nporbits);
	ecg->init_ECG();
	ecg->build_ecg();

	g_ctrlShowMCG->EnableWindow(TRUE);
	
	if(DebugOn == 1)
	{
		fp = fopen("detect_process_log.txt", "a");
		fprintf(fp, "finish constructing ECG!\n");
		fclose(fp);
	}

	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("%d nodes and %d edges of ECG have been computed.\n"), ecg->nlist->nenodes,
			ecg->elist->nedges);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for constructing the ECG is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}

	g_ctrlShowSep->EnableWindow(TRUE);
	g_ctrlShowMCG->EnableWindow(TRUE);  //don't allow user to modify the displaying mode
	g_ctrlEnhancedStreamlinesPlace->EnableWindow(TRUE); //enable enhanced streamline placement

	g_ctrlButtonCalSeps->EnableWindow(TRUE);            //enable separatrix calculation
	g_ctrlButtonExtracPOs->EnableWindow(TRUE);          //enable periodic orbit extraction
	g_ctrlButtonBrowsePLYFile->EnableWindow(TRUE);      //enable loading the new ply file
	g_ctrlButtonMorseDecomp->EnableWindow(TRUE);
}



void CIBFVDlg::OnBnClickedButtonExtractperiodicorbits()
{
	// TODO: Add your control notification handler code here

	/*extract periodic orbits*/
	m_chkShowPeriodicOrbitsOn = TRUE;
	pclGlView->ShowPeriodicOrbitsOn = 0;
	m_chkShowMCG = TRUE;
	m_chkShowSepsOn = TRUE;
	m_chkShowFixedPtsOn = TRUE;

	m_ctrlShowSep.EnableWindow(FALSE);
	m_ctrlShowMCG.EnableWindow(FALSE);  //don't allow user to modify the displaying mode

	m_ctrlButtonCalSeps.EnableWindow(FALSE);            //disable separatrix calculation
	m_ctrlButtonExtracPOs.EnableWindow(FALSE);          //disable periodic orbit extraction
	m_ctrlButtonBrowsePLYFile.EnableWindow(FALSE);      //disable loading the new ply file
	m_ctrlEnhancedStreamlinesPlace.EnableWindow(FALSE); //disable enhanced streamline placement
	m_ctrlButtonMorseDecomp.EnableWindow(FALSE);

	pclGlView->ShowPeriodicOrbitsOn = 1;


	CString str;
	int loc;
	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start extracting periodic orbits...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}
	UpdateData(FALSE);

	//Create a multiple thread to run it
	DWORD threadID;
	thread = CreateThread(NULL,
		0,
		(LPTHREAD_START_ROUTINE) extract_periodicorbits,
		NULL,
		CREATE_SUSPENDED,
		&threadID);

	if(thread == NULL)
	{
		MessageBox("Creating thread failed!", "Error");
		return;
	}

	if(!SetThreadPriority(thread, THREAD_PRIORITY_NORMAL))
	{
		MessageBox("Seting priority of the thread failed!", "Error");
		return;
	}

	if((ResumeThread(thread)) == -1)
	{
		MessageBox("Resuming thread failed!", "Error");
		return;
	}

}


/*the outer Morse decomposition routine for multiple threads*/
void MorseDecomp_extern()
{
	CString str;
	int loc;
	FILE *fp;

	/*perform Morse decompostion*/
	if(morse_decomp != NULL)
		delete morse_decomp;
	morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/
	morse_decomp->morse_decomp();

	g_pclGlView->ShowSCCsOn = 1;

	/*compute the MCG*/
	if(mcg != NULL)
		delete mcg;
	
	mcg = new MCG_Graph();
	
	//fp=fopen("detect_porbit.txt","w");
	//fprintf(fp, "start initializing the MCG\n");
	//fclose(fp);
	
	mcg->init_MCG();

	//fp=fopen("detect_porbit.txt","a");
	//fprintf(fp, "start constructing the MCG\n");
	//fclose(fp);

	mcg->build_mcg();

	//fp=fopen("detect_porbit.txt","a");
	//fprintf(fp, "finish constructing the MCG\n");
	//fclose(fp);

	g_pCgraphView->ShowMCGOn = 1;

	if(ecg != NULL)
		g_ctrlShowMCG->EnableWindow(TRUE);

	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("%d Morse sets have been computed.\n"), 
			mcg->nlist->nmnodes);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for the Morse Decomposition is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}
	
	g_ctrlShowMCG->EnableWindow(TRUE);  //enable displaying mode

	g_ctrlButtonExtracPOs->EnableWindow(TRUE);          //enable periodic orbit extraction
	g_ctrlButtonBrowsePLYFile->EnableWindow(TRUE);      //enable loading the new ply file
	g_ctrlButtonMorseDecomp->EnableWindow(TRUE);        //enable new Morse decomposition

}


double global_tau;

void update_SCC()
{
	
	FILE *fp;
	CString str;
	int loc;

	if(morse_decomp != NULL)
		delete morse_decomp;
	morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/

	/*record the performance*/
	morse_decomp->morse_decomp_tau(global_tau);

	/*
	   Let us output a temporary graph for testing
	*/
	morse_decomp->save_dirGraph_FG("temp_dirGraph.dg");

	g_pclGlView->ShowSCCsOn = 1;


	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("Finish computing FG and extracting SCCs. There are %d edges in FG\n"),
			morse_decomp->dg->elist->nedges);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for computing FG is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}


	if(ecg != NULL)
		g_ctrlShowMCG->EnableWindow(TRUE);


	/*compute the MCG*/
	clock_t start, finish;
	start = clock();
	if(mcg != NULL)
		delete mcg;
	
	//fp=fopen("detect_porbit.txt","w");
	//fprintf(fp, "start initializing the MCG\n");
	//fclose(fp);

	mcg = new MCG_Graph();
	mcg->init_MCG();
	mcg->build_mcg();
	
	//fp=fopen("detect_porbit.txt","a");
	//fprintf(fp, "finish constructing the MCG\n");
	//fclose(fp);
	
	g_pCgraphView->ShowMCGOn = 1;

	finish = clock();
	fp = fopen("tvcg_performance.txt", "a");
	fprintf(fp, "time for constructing MCG is %f. \n",(double)(finish - start)/CLOCKS_PER_SEC);
	fprintf(fp, "the number of edges in directed graph is: %d\n",  morse_decomp->dg->elist->nedges);
	fprintf(fp, "the number of Morse sets of tau = %f is: %d\n\n", global_tau, mcg->nlist->nmnodes);
	fprintf(fp, "the number of edges in MCG: %d\n\n", mcg->elist->nedges);
	fclose(fp);

	if(DebugOn == 1)
	{
		str.Format(_T("Finish computing the MCG. It contains %d nodes and %d edges\n"),
			mcg->nlist->nmnodes, mcg->elist->nedges);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for the computing MCG is %f seconds\n"),(double)(finish - start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}
	
	if(DebugOn == 1)
	{
		g_finish = clock();
		str.Format(_T("time for this Morse Decomposition is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format("--------------------------------------");
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}
	
	g_ctrlShowMCG->EnableWindow(TRUE);  //enable displaying mode

	g_ctrlButtonExtracPOs->EnableWindow(TRUE);          //enable periodic orbit extraction
	g_ctrlButtonBrowsePLYFile->EnableWindow(TRUE);      //enable loading the new ply file
	g_ctrlButtonMorseDecomp->EnableWindow(TRUE);        //enable new Morse decomposition


	// for Cooling Jacket hierarchy example  07/14/2010
	RegionTauMap temp_rt;
	//temp_rt.set_exclude_MorseSet(37);

	for (int i=0; i<object->tlist.ntris; i++)
	{
		object->tlist.tris[i]->exclude = false;
		object->tlist.tris[i]->local_index = -1;
	}

	for (int i=0; i<mcg->nlist->nmnodes; i++)
	{
		temp_rt.set_exclude_MorseSet(i);
	}

}


void CIBFVDlg::OnBnClickedButtonMorsedecomp()
{
	// TODO: Add your control notification handler code here
	CString str;
	int loc;
	m_chkShowMorseSets = TRUE;
	//pclGlView->ShowSCCsOn = 1;
	m_chkShowMCG = TRUE;
	//pCgraphView->ShowMCGOn = 1;

	m_ctrlShowMCG.EnableWindow(FALSE);  //don't allow user to modify the displaying mode

	m_ctrlButtonExtracPOs.EnableWindow(FALSE);          //disable periodic orbit extraction
	m_ctrlButtonBrowsePLYFile.EnableWindow(FALSE);      //disable loading the new ply file
	m_ctrlButtonMorseDecomp.EnableWindow(FALSE);        //disable new Morse decomposition

	if(object->slist.nsingularities == 0)
		object->capture_Singularities();

	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start performing Morse Decomposition...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}
	UpdateData(FALSE);
	
	
	//Create a multiple thread to run it
	DWORD threadID;
	thread = CreateThread(NULL,
		0,
		(LPTHREAD_START_ROUTINE) MorseDecomp_extern,
		NULL,
		CREATE_SUSPENDED,
		&threadID);

	if(thread == NULL)
	{
		MessageBox("Creating thread failed!", "Error");
		return;
	}

	if(!SetThreadPriority(thread, THREAD_PRIORITY_NORMAL))
	{
		MessageBox("Seting priority of the thread failed!", "Error");
		return;
	}

	if((ResumeThread(thread)) == -1)
	{
		MessageBox("Resuming thread failed!", "Error");
		return;
	}
}

int StreamlineData = 0;


/*outer routine for even streamline placement*/
//DWORD place_streamlines_extern( LPVOID lpParam ) 
void place_streamlines_extern() 
{ 
    //HANDLE hStdout;
    //int *pData;

    //TCHAR msgBuf[256];
    //size_t cchStringSize;
    //DWORD dwChars;

    //hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
    //if( hStdout == INVALID_HANDLE_VALUE )
    //    return 1;

    // Cast the parameter to the correct data type.

    //pData = (int *)lpParam;
	
	//if(*pData == 1)
	//	extract_periodicorbits();
	//evenplace->place_streamlines(*pData);

	//FILE *fp1;
	//fp1 = fopen("streamline_err_log.txt", "w");
	//fprintf(fp1, "the import data is %d ...\n", StreamlineData);
	//fclose(fp1);
	if(object->slist.nsingularities == 0)
		object->capture_Singularities();
	g_pclGlView->ShowFixedPtOn = 1;

	if(StreamlineData == 1)
		extract_periodicorbits();
	evenplace->place_streamlines(StreamlineData);

	ndisplay_trajs = evenplace->evenstreamlines->ntrajs;


	g_ctrlButtonCalSeps->EnableWindow(TRUE);
	g_ctrlButtonExtracPOs->EnableWindow(TRUE);

	g_pclGlView->EvenStreamlinePlacement = 1;

	/*save to the file */

	if(save_streamlines_tofile)
	{
		const char *filename = SetStreamlinefiletoSave;
		if(StreamlineData == 0)
			evenplace->save_to_a_file(filename);
		else
			evenplace->save_to_a_file(filename,1);

		g_ctrlButtonStreamlineLoad->EnableWindow(TRUE);
	}



    // Free the memory allocated by the caller for the thread 
    // data structure.

    //HeapFree(GetProcessHeap(), 0, pData);

	//FILE* fp = fopen("thread_err_log.txt", "w");
	//fprintf(fp, "destroy the even streamline placement\n");
	//fclose(fp);

    //return 0; 
} 



void CIBFVDlg::OnBnClickedButtonPlacestreamlines()
{
	// TODO: Add your control notification handler code here

	if(MessageBox("This will take a long time, are sure you want to go on?", "Info",
		MB_YESNO) == IDNO)
	{
		return;
	}

	if(MessageBox("Do you want to save the results?", "Info",
		MB_YESNO) == IDYES)
	{
		m_chkSaveStreamlineResults = TRUE;
		save_streamlines_tofile = true;
		UpdateData(TRUE);
		SetStreamlinefiletoSave = m_edSetStreamlinefiletoSave;
	}
	else
	{
		m_chkSaveStreamlineResults = FALSE;
		save_streamlines_tofile = false;
	}

	/*place the even streamlines*/
	StreamlinePlace_dsep = m_edStreamlinePlace_dsep;
	StreamlinePlace_slength = m_edStreamlinePlace_slength;
	m_ctrlButtonStreamlineLoad.EnableWindow(FALSE);

	m_chkShowFixedPtsOn = TRUE;


	//if(m_chkSaveStreamlineResults == TRUE)
	//{
	//}


	FILE *fp;
	if(evenplace == NULL)
	{
		evenplace = new EvenStreamlinePlace();
	}
	
	

	//fp = fopen("streamline_err_log.txt", "a");
	//fprintf(fp, "start initializing...\n");
	//fprintf(fp, "%ld\n", evenplace);
	//fclose(fp);

	evenplace->init();
	evenplace->reset_placement();
	

	//int *pData = new int[1];
	//int *pData = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
	//sizeof(int));

	if(m_chkEnhancedStreamlinePlacementOn == FALSE)
		//(*pData) = 0;
		StreamlineData = 0;
	else{
		//(*pData) = 1;
		StreamlineData = 1;
	}

	m_ctrlButtonCalSeps.EnableWindow(FALSE);
	m_ctrlButtonExtracPOs.EnableWindow(FALSE);
	
	pclGlView->EvenStreamlinePlacement = 1;

	g_start = clock();


	//Create a multiple thread to run it
	DWORD threadID;
	thread = CreateThread(NULL,
		0,
		(LPTHREAD_START_ROUTINE) place_streamlines_extern,
		//pData,
		//pStreamlineData,
		NULL,
		CREATE_SUSPENDED,
		&threadID);

	if(thread == NULL)
	{
		MessageBox("Creating thread failed!", "Error");
		return;
	}

	if(!SetThreadPriority(thread, THREAD_PRIORITY_NORMAL))
	{
		MessageBox("Seting priority of the thread failed!", "Error");
		return;
	}

	if((ResumeThread(thread)) == -1)
	{
		MessageBox("Resuming thread failed!", "Error");
		return;
	}

	//if(m_chkEnhancedStreamlinePlacementOn == FALSE)
	//	evenplace->place_streamlines(0);
	//else
	//{
	//	m_ctrlButtonCalSeps.EnableWindow(FALSE);
	//	m_ctrlButtonExtracPOs.EnableWindow(FALSE);;

	//	/*need to dectect periodic orbits and compute the separatrices first*/
	//	extract_periodicorbits();
	//	evenplace->place_streamlines(1);
	//}

}


/*save the content in the flow view window into a .bmp file*/
void CIBFVDlg::OnBnClickedButtonSavebmpimg()
{
	// TODO: Add your control notification handler code here
	CFile f;

	char strFilter[] = { "Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(FALSE, ".bmp", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f2 = FileDlg.GetFileName();
		CString f3 = f2.Left(f2.ReverseFind('.'))+".bmp";

		const char *filename = f3;

		/* Try to set different OpenGl window */
			
		//wglMakeCurrent(pConleygraphView->m_hDC, pConleygraphView->m_hglRC); //set the current content is the C-graph window

		//wglMakeCurrent(pConleygraphView->m_hDC, pConleygraphView->m_hglRC);
		//pConleygraphView->DrawGLScene(GL_RENDER);

		WriteBmp(filename);
	
		//wglMakeCurrent(pclGlView->m_hDC, pclGlView->m_hglRC); //set the current content is the field window
	}
}

void CIBFVDlg::OnBnClickedCheckShowvfmagnitude()
{
	// TODO: Add your control notification handler code here
	if(m_chkColorVFMagOn == FALSE)
	{
		m_chkColorVFMagOn = TRUE;
		pclGlView->ShowColorVFMagOn = 1;
	}
	else
	{
		m_chkColorVFMagOn = FALSE;
		pclGlView->ShowColorVFMagOn = 0;
	}
}


/*try the tau map idea here
*/
//extern void build_mcg();


void CIBFVDlg::OnBnClickedButtonSettau()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	//////Recalculate the SCC again
	global_tau = (double)m_edTau;

	CString str;
	int loc;
	m_chkShowMorseSets = TRUE;
	m_chkShowMCG = TRUE;

	m_ctrlShowMCG.EnableWindow(FALSE);  //don't allow user to modify the displaying mode

	m_ctrlButtonExtracPOs.EnableWindow(FALSE);          //disable periodic orbit extraction
	m_ctrlButtonBrowsePLYFile.EnableWindow(FALSE);      //disable loading the new ply file
	m_ctrlButtonMorseDecomp.EnableWindow(FALSE);        //disable new Morse decomposition

	if(object->slist.nsingularities == 0)
		object->capture_Singularities();

	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start performing Morse Decomposition...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}
	UpdateData(FALSE);

	/////Create a multiple thread to run it
	//DWORD threadID;
	//thread = CreateThread(NULL,
	//	0,
	//	(LPTHREAD_START_ROUTINE) update_SCC,
	//	NULL,
	//	CREATE_SUSPENDED,
	//	&threadID);

	//if(thread == NULL)
	//{
	//	MessageBox("Creating thread failed!", "Error");
	//	return;
	//}

	//if(!SetThreadPriority(thread, THREAD_PRIORITY_NORMAL))
	//{
	//	MessageBox("Seting priority of the thread failed!", "Error");
	//	return;
	//}

	//if((ResumeThread(thread)) == -1)
	//{
	//	MessageBox("Resuming thread failed!", "Error");
	//	return;
	//}

	update_SCC();
}

BOOL CIBFVDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	// TODO: Add your message handler code here and/or call default
	 if(zDelta>0)  /*zoom in*/
 {
  pclGlView->zoom_factor += 0.05;

  if(pclGlView->zoom_factor > 1){
   //SCALE /= pclGlView->zoom_factor;

   //if(singsize > 0.004)
   // singsize /= pclGlView->zoom_factor;
  }

  if(SCALE > 1)
  {
   //tmax   = npix/(SCALE*npn);
    //dmax   = SCALE/npix;
   dmax = 1.8/npix/pclGlView->zoom_factor;
   pclGlView->makePatterns();
  }
 }

 else
 {
  if( pclGlView->zoom_factor > 0.05 )
  {
   pclGlView->zoom_factor -= 0.05;

   if(pclGlView->zoom_factor > 1){
    //SCALE *= pclGlView->zoom_factor;

   //if(singsize > 0.004)
   //  singsize *= pclGlView->zoom_factor;
   }

   if(SCALE > 1)
   {
    //tmax   = npix/(SCALE*npn);
     //dmax   = SCALE/npix;
   dmax = 1.8/npix/pclGlView->zoom_factor;
    pclGlView->makePatterns();
   }
  }
 }
 
pclGlView->ReCalTexcoord();

 g_zoom_factor = pclGlView->zoom_factor;  // 02/09/2010

 OnPaint();


 return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

void CIBFVDlg::OnMButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	double s, t;

	double position[3];

	ScreenToSecondWin(point.x, point.y, firstwin_leftbottom.x, firstwin_leftbottom.y,
					firstwin_rightx, firstwin_bottomy, 0, 0, 1, 1, position[0], position[1]);
	s = position[0];
	t = position[1];

	if((s < 0) || (s > 1) || (t < 0) || (t > 1))
	{
		s_old = s;
		t_old = t;
		return;
	}
	s_old = s;
	t_old = t;
	m_MiddleButtonDown = TRUE;

	CDialog::OnMButtonDown(nFlags, point);
}

void CIBFVDlg::OnMButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	m_MiddleButtonDown = FALSE;
	pclGlView->ReCalTexcoord();
	CDialog::OnMButtonUp(nFlags, point);
}

void CIBFVDlg::OnBnClickedExrot()
{
	// TODO: Add your control notification handler code here
	int i;
	CFile f;

	char strFilter[] = { "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(FALSE, ".txt", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{

		CString f2 = FileDlg.GetFileName();
		const char *filename = f2;

		FILE *fp = fopen(filename, "w");
		//for(i = 0; i < 4; i++)
		//{
		//	//
		//	fprintf(fp, "%f,%f,%f,%f\n", g_pclGlView->rotmat[i][0],
		//								 g_pclGlView->rotmat[i][1],
		//								 g_pclGlView->rotmat[i][2],
		//								 g_pclGlView->rotmat[i][3]);
		//}

		//fclose(fp);

		/*  output the transformation  */
		for(i = 0; i < 4; i++)
		{
			//
			fprintf(fp, "%f,%f,%f,%f\n", g_pclGlView->rotmat[i][0],
										 g_pclGlView->rotmat[i][1],
										 g_pclGlView->rotmat[i][2],
										 g_pclGlView->rotmat[i][3]);
		}

		/*   output the zoom-in factor  */
		fprintf (fp, "%f\n", g_pclGlView->zoom_factor);

		/*   output the translation  */

		fprintf (fp, "%f,%f\n", trans_x, trans_y);

		fclose(fp);

	}
}

void CIBFVDlg::OnBnClickedInrot()
{
	// TODO: Add your control notification handler code here
	int i;
	CFile f;

	char strFilter[] = { "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".txt", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{

		CString f2 = FileDlg.GetFileName();
		const char *filename = f2;

		FILE *fp = fopen(filename, "r");
		if(fp == NULL)
		{
			MessageBox("Can not open file!", "Failed!");
			return;
		}

		//for(i = 0; i < 4; i++)
		//{
		//	//
		//	fscanf(fp, "%f,%f,%f,%f\n", &g_pclGlView->rotmat[i][0],
		//								&g_pclGlView->rotmat[i][1],
		//								&g_pclGlView->rotmat[i][2],
		//								&g_pclGlView->rotmat[i][3]);
		//}

		//fclose(fp);
		/*  get the rotation matrix  */

		for(i = 0; i < 4; i++)
		{
			//
			fscanf(fp, "%f,%f,%f,%f\n", &g_pclGlView->rotmat[i][0],
										&g_pclGlView->rotmat[i][1],
										&g_pclGlView->rotmat[i][2],
										&g_pclGlView->rotmat[i][3]);
		}

		/*  get the scaling  */

		float zoom;

		fscanf(fp, "%f\n", &zoom);

		g_pclGlView->zoom_factor=zoom;

		/*  get the translation  */

		float x_trans, y_trans;

		fscanf (fp, "%f,%f\n", &x_trans, &y_trans);

		trans_x = x_trans;
		trans_y = y_trans;

		fclose(fp);

		OnPaint();

	}
}

void CIBFVDlg::OnEnChangeEdit2()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEdit4()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEdit5()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEdit6()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEdit7()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEdit8()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnBnClickedLocalRefine()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CString str;
	int loc;
	m_chkShowMorseSets = TRUE;
	m_chkShowMCG = TRUE;


	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start performing Local Morse Decomposition...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}
	UpdateData(FALSE);
	/////////////////////////////////////////////////
	regiontau->init_local_graph_2();   // added by Guoning on 07/06/2010
	regiontau->init_tau_pts_at_tris();
	regiontau->init_tau_pts_at_verts();
	regiontau->RefineRegion(local_morse,local_tau);
	//regiontau->conley->compute_conley_index();
	/////////////////////////////////////////////////

	if(DebugOn == 1)
	{
		g_finish = clock();		
		str.Format(_T("time for this process is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}




	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedAutoRefine()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CString str;
	int loc;
	m_chkShowMorseSets = TRUE;
	m_chkShowMCG = TRUE;


	if(m_chkDebugOn == TRUE)
	{
		g_start = clock();
		str.Format("--------------------------------------");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
		str.Format("Start performing Auto Morse Decomposition...");
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str);
	}
	UpdateData(FALSE);

	for(int i=0; i<object->tlist.ntris; i++)
	{
		object->tlist.tris[i]->used_tau = 0;
	}

	if (!noTmax)
	{
	//////////////////////////////////////////////////////////////
	regiontau->init_local_graph_2();   // added by Guoning on 07/06/2010
	regiontau->init_tau_pts_at_tris();
	regiontau->init_tau_pts_at_verts();

	regiontau->Auto_Refine(tau_max,ini_tau,min_pri,iter_max);
	//regiontau->Auto_Refine_2(tau_max);
	//////////////////////////////////////////////////////////////
	}
	else
	{
	regiontau->init_local_graph_2();   // added by Guoning on 07/06/2010
	regiontau->init_tau_pts_at_tris();
	regiontau->init_tau_pts_at_verts();
		regiontau->Auto_Refine(ini_tau, min_pri, 4);
	}

	/*
	   Output the min tau and max tau values for the whole mesh
	*/
	double tau_min = 1e10;
	double tau_max = -1e10;

	for (int i=0; i<object->tlist.ntris; i++)
	{
		if (object->tlist.tris[i]->used_tau>tau_max) tau_max = object->tlist.tris[i]->used_tau;
		if (object->tlist.tris[i]->used_tau<tau_min) tau_min = object->tlist.tris[i]->used_tau;
	}

	if(DebugOn == 1)
	{
		g_finish = clock();		
		str.Format(_T("time for this process is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		/*  print out the number of Morse sets and number of connection edges  */
		int i;
		int n_mcg_nodes = 0;
		for (i=0; i<mcg->nlist->nmnodes; i++)
		{
			if (mcg->nlist->mnodes[i]->cancelled) continue;
			n_mcg_nodes ++;
		}
		int n_mcg_edges = 0;
		for (i=0; i<mcg->elist->nedges; i++)
		{
			if (mcg->elist->edges[i]->cancel) continue;
			n_mcg_edges ++;
		}
		str.Format(_T("Finish computing the MCG. It contains %d nodes and %d edges\n"),
			n_mcg_nodes, n_mcg_edges);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);

		str.Format(_T("The maximum tau value is %f,\n"),
			tau_max);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("The minimum tau value is %f.\n"),
			tau_min);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	}
	UpdateData(FALSE);
}


///////////////////////////
bool showrealindex = false;

void CIBFVDlg::OnBnClickedShowrealid()
{
	// TODO: Add your control notification handler code here
	if(m_chkShowRealMorseID==FALSE)
	{
		m_chkShowRealMorseID = TRUE;
		showrealindex = true;
	}
	else
	{
		m_chkShowRealMorseID = FALSE;
		showrealindex = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedDisplayMorseConnection()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	//pclGlView->display_morse_connection(Morse_Connection);
	pclGlView->morseC=Morse_Connection;
	pclGlView->ShowMorseConn=1;
	pclGlView->ShowTriangleConn=0;

	
	

	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedDisplayTriangleConnection()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	pclGlView->triC=Triangle_Connection;

	pclGlView->ShowMorseConn=0;
	pclGlView->ShowTriangleConn=1;




	//pclGlView->display_triangle_connection(Triangle_Connection);

	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedDisplayScc()
{
	// TODO: Add your control notification handler code here
	pclGlView->display_SCCs(GL_RENDER);

}

void CIBFVDlg::OnEnChangeEdit9()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEdit10()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnBnClickedSampleVis()
{
	// TODO: Add your control notification handler code here
	if(SampleVis==FALSE)
	{
		SampleVis=TRUE;
		pclGlView->ShowEdgeSamplesOn=true;
	}
	else
	{
		SampleVis=FALSE;
		pclGlView->ShowEdgeSamplesOn=false;
	}
	UpdateData(FALSE);
}

/*************************************************/
/*
    Right click the mesh to select a triangle 02/10/2010
*/

void CIBFVDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	double position[3];

	m_RightButtonDown = TRUE;

	ScreenToSecondWin(point.x-25, point.y-45, firstwin_leftbottom.x, firstwin_leftbottom.y,
					firstwin_rightx, firstwin_bottomy, 0, 0, 1, 1, position[0], position[1]);

	pclGlView->HitProcess(position[0], position[1]);
	
extern int  investigate_tri;

    if(pclGlView->selected_triangle < 0)
	{
		//MessageBox("Not select a triangle, please try again!", "Error", MB_OK);
		m_RightButtonDown = FALSE;
		return;
	}

	else
		investigate_tri = pclGlView->selected_triangle;

	CDialog::OnRButtonDown(nFlags, point);
}

void CIBFVDlg::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	m_RightButtonDown = FALSE;

	CDialog::OnRButtonUp(nFlags, point);
}

void CIBFVDlg::OnBnClickedCheckShowtrimapping()
{
	// TODO: Add your control notification handler code here
	if (m_chkShowTriMappingOn == FALSE)
	{
		m_chkShowTriMappingOn = TRUE;
		pclGlView->ShowTriMappingOn = true;
	}
	else
	{
		m_chkShowTriMappingOn = FALSE;
		pclGlView->ShowTriMappingOn = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedShowbackward()
{
	// TODO: Add your control notification handler code here
	if(SampleBackward==TRUE)
	{
		SampleBackward=FALSE;
		pclGlView->ShowBackward=1;
	}
	else
	{
		SampleBackward=TRUE;
		pclGlView->ShowBackward=0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedChangeEdge()
{
	// TODO: Add your control notification handler code here
	if(sampling_edge==2)sampling_edge=0;
	else
		sampling_edge++;
	pclGlView->sampling_edge=sampling_edge;
}

void CIBFVDlg::OnBnClickedCheckShowRegion()
{
	// TODO: Add your control notification handler code here
	if (ShowRegion == FALSE)
	{
		ShowRegion  = TRUE;
		pclGlView->ShowConnectionRegion = 1;
	}
	else
	{
		ShowRegion  = FALSE;
		pclGlView->ShowConnectionRegion  = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowboundary()
{
	// TODO: Add your control notification handler code here
	if (ShowBoundary == FALSE)
	{
		ShowBoundary   = TRUE;
		pclGlView->ShowBoundary  = 1;
	}
	else
	{
		ShowBoundary   = FALSE;
		pclGlView->ShowBoundary  = 0;
	}
	UpdateData(FALSE);

}

void CIBFVDlg::OnBnClickedShowconleymcg()
{
	// TODO: Add your control notification handler code here
	if (ShowConleyMCG== FALSE)
	{
		ShowConleyMCG  = TRUE;
		pCgraphView->ShowConleyCircle  = 1;
	}
	else
	{
		ShowConleyMCG  = FALSE;
		pCgraphView->ShowConleyCircle  = 0;
	}
	UpdateData(FALSE);

}
int Cal_Regions=0;
void CIBFVDlg::OnBnClickedCheckComputeConnectionRegion()
{
	// TODO: Add your control notification handler code here
	if (ComputeRegion== FALSE)
	{
		ComputeRegion  = TRUE;
		Cal_Regions = 1;
	}
	else
	{
		ComputeRegion  = FALSE;
		Cal_Regions  = 0;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedButtonRefinemcgedge()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	regiontau->RefineConnMCGE(mnode1,mnode2,Conn_tau);
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedButtonRefineconnreg()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	regiontau->RefineConnRegion(Conn_tau);
	UpdateData(FALSE);
}

void CIBFVDlg::OnEnChangeEdit1Morseset1()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEditMorseset2()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnEnChangeEditTauvalue()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
	global_tau = (double)m_edTau;
}

void CIBFVDlg::OnEnChangeEditSampleerror()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
	edge_sample_error = m_edEdgeSampleError;
}

extern bool enFastRefinement;

void CIBFVDlg::OnBnClickedCheckEnfastrefine()
{
	// TODO: Add your control notification handler code here

	if (m_chkEnFastRefinement == FALSE)
	{
		m_chkEnFastRefinement = TRUE;
		enFastRefinement = true;
	}
	else
	{
		m_chkEnFastRefinement = FALSE;
		enFastRefinement = false;
	}
}

void CIBFVDlg::OnEnChangeEdit11()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
	UpdateData(TRUE);
}

void CIBFVDlg::OnBnClickedButtonOutputdirgraph()
{
	// TODO: Add your control notification handler code here
	CFile f;

	char strFilter[] = { "Directed Graph Files (*.dg)|*.dg|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(FALSE, ".dg", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f2 = FileDlg.GetFileName();
		CString f3 = f2.Left(f2.ReverseFind('.'))+".dg";

		const char *filename = f3;

		char str[256];
		strcpy (str, filename);

		morse_decomp->save_dirGraph_FG(str);
	}	
}

void CIBFVDlg::OnBnClickedButtonLoaddirgraph()
{
	// TODO: Add your control notification handler code here
	CFile f;

	char strFilter[] = { "Directed Graph Files (*.dg)|*.dg|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".dg", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f1 = FileDlg.GetPathName();
		CString f2 = FileDlg.GetFileName();
		CString f4 = f2.Right(f2.GetLength()-f2.ReverseFind('.'));
		CString txt = ".dg";
		if(f4!=txt)
		{
			MessageBox("Not a compatible file format, please select a .dg file", "Error");
			return;
		}
		CString f3 = f2.Left(f2.ReverseFind('.'))+".dg";

		const char *filename = f3;

		char str[256];
		strcpy (str, filename);

		object->capture_Singularities();
		morse_decomp->load_dirGraph_FG(str);

		/*
		   perform the rest computation of the Morse decomposition
		*/

		/*  extract the strongly connected components  */
		morse_decomp->dg->find_SCCS();

		morse_decomp->build_SCCElemList();

		morse_decomp->mark_all_valid_SCCS();

		///*  compute the MCG  */
		if(mcg != NULL)
			delete mcg;
		
		mcg = new MCG_Graph();
		mcg->init_MCG();
		//EnConleyIndexComp = false;
		mcg->build_mcg();

		/// Mark the Morse sets
		morse_decomp->mark_cur_MorseSets();

		pclGlView->ShowSCCsOn = 1;
		pCgraphView->ShowMCGOn = 1;
		
		CString str1;
		int loc;
		str1.Format(_T("Finish computing the MCG. It contains %d nodes and %d edges\n"),
			mcg->nlist->nmnodes, mcg->elist->nedges);
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str1);

		output_MS("MS_out.txt", mcg, morse_decomp);

	}

	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckEnconleyindexcomp()
{
	// TODO: Add your control notification handler code here

	if (m_chkEnConleyIndexComp == FALSE)
	{
		m_chkEnConleyIndexComp = TRUE;
		EnConleyIndexComp = true;
	}
	else
	{
		m_chkEnConleyIndexComp = FALSE;
		EnConleyIndexComp = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckRemoveredundantedges()
{
	// TODO: Add your control notification handler code here
	if (m_chkRemRedundantMCGEdges == FALSE)
	{
		m_chkRemRedundantMCGEdges = TRUE;
		RemRedundantMCGEdges = true;
	}
	else
	{
		m_chkRemRedundantMCGEdges = FALSE;
		RemRedundantMCGEdges = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckGreytexture()
{
	// TODO: Add your control notification handler code here
	if (m_chkEnGreyTexture == FALSE)
	{
		m_chkEnGreyTexture = TRUE;
		EnGreyTexture = true;

		pclGlView->makePatterns();

	}
	else
	{
		m_chkEnGreyTexture = FALSE;
		EnGreyTexture = false;
		pclGlView->makePatterns();
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckNoshiny()
{
	// TODO: Add your control notification handler code here
	if (m_chkNotShiny == FALSE)
	{
		m_chkNotShiny = TRUE;
		NotShiny = true;
	}
	else
	{
		m_chkNotShiny = FALSE;
		NotShiny = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckDisablelighting()
{
	// TODO: Add your control notification handler code here
	if (m_chkDisableLighting == FALSE)
	{
		m_chkDisableLighting = TRUE;
		DisableLighting = true;
	}
	else
	{
		m_chkDisableLighting = FALSE;
		DisableLighting = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckDisablebackground()
{
	// TODO: Add your control notification handler code here
	if (m_chkDisableBackground == FALSE)
	{
		m_chkDisableBackground = TRUE;
		DisableBackground = true;
	}
	else
	{
		m_chkDisableBackground = FALSE;
		DisableBackground = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowtubelike()
{
	// TODO: Add your control notification handler code here

	if (m_chkEnTubeLikeVis == FALSE)
	{
		m_chkEnTubeLikeVis = TRUE;
		EnTubeLikeVis = true;
	}
	else
	{
		m_chkEnTubeLikeVis = FALSE;
		EnTubeLikeVis = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowtaudistribution()
{
	// TODO: Add your control notification handler code here

	if (m_chkShowTDistribution == FALSE)
	{
		m_chkShowTDistribution = TRUE;
		ShowTDistribution = true;
		morse_decomp->get_t_max_min();

		FILE *fp = fopen("tdist.txt", "w");
		fprintf(fp, "tmax %f, tmin %f", morse_decomp->tau_max, morse_decomp->tau_min);
		fclose(fp);
	}
	else
	{
		m_chkShowTDistribution = FALSE;
		ShowTDistribution = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckDisplaydiffecgmcg()
{
	// TODO: Add your control notification handler code here
	if (m_chkShowDiffECGMCG == FALSE)
	{
		m_chkShowDiffECGMCG = TRUE;
		morse_decomp->compare_with_ECG();
		ShowDiffECGMCG = true;
	}
	else
	{
		m_chkShowDiffECGMCG = FALSE;
		ShowDiffECGMCG = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowdiffmcgs()
{
	// TODO: Add your control notification handler code here
	if (m_chkShowMCGDiff == FALSE)
	{
		m_chkShowMCGDiff = TRUE;
		ShowMCGDiff = true;

		int i;
		int diff_count = 0;
		for (i=0; i<object->tlist.ntris; i++)
		{
			if (object->tlist.tris[i]->counter %2 == 1)
				diff_count ++;
		}

		CString str1;
		int loc;
		str1.Format(_T("The number of triangles that are different is %d\n"),
			diff_count);
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str1);
	}
	else
	{
		m_chkShowMCGDiff = FALSE;
		ShowMCGDiff = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckAutostop()
{
	// TODO: Add your control notification handler code here
	if (m_chkNoTMax == FALSE)
	{
		m_chkNoTMax = TRUE;
		noTmax = true;
	}
	else
	{
		m_chkNoTMax = FALSE;
		noTmax = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedRadioEuler1()
{
	// TODO: Add your control notification handler code here
	m_rdIntegrator_opt = 0;
	Integrator_opt = 0;
}

void CIBFVDlg::OnBnClickedRadioRk2()
{
	// TODO: Add your control notification handler code here
	m_rdIntegrator_opt = 1;
	Integrator_opt = 1;
}

void CIBFVDlg::OnBnClickedRadioRk4()
{
	// TODO: Add your control notification handler code here
	m_rdIntegrator_opt = 2;
	Integrator_opt = 2;
}

void CIBFVDlg::OnBnClickedCheckRemovedisconn()
{
	// TODO: Add your control notification handler code here
	if (m_chkRemoveDisconnMSOn == FALSE)
	{
		m_chkRemoveDisconnMSOn = TRUE;
		RemoveDisconnMSOn = true;
	}
	else
	{
		m_chkRemoveDisconnMSOn = FALSE;
		RemoveDisconnMSOn = false;
	}
	UpdateData(FALSE);
}



void CIBFVDlg::OnBnClickedButtonOutputsubgraph()
{
	// TODO: Add your control notification handler code here
	CFile f;

	char strFilter[] = { "Directed Graph Files (*.dg)|*.dg|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(FALSE, ".dg", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f2 = FileDlg.GetFileName();
		CString f3 = f2.Left(f2.ReverseFind('.'))+".dg";

		const char *filename = f3;

		char str[256];
		strcpy (str, filename);

		morse_decomp->out_sub_FG(str);
	}	
}

void CIBFVDlg::OnBnClickedButtonLoad1()
{
	// TODO: Add your control notification handler code here

	CFile f;

	char strFilter[] = { "Directed Graph Files (*.dg)|*.dg|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".dg", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f1 = FileDlg.GetPathName();
		CString f2 = FileDlg.GetFileName();
		CString f4 = f2.Right(f2.GetLength()-f2.ReverseFind('.'));
		CString txt = ".dg";
		if(f4!=txt)
		{
			MessageBox("Not a compatible file format, please select a .dg file", "Error");
			return;
		}
		CString f3 = f2.Left(f2.ReverseFind('.'))+".dg";

		const char *filename = f3;

		char str[256];
		strcpy (str, filename);

		L1_morse->load_sub_FG(str);

		/*
		   perform the rest computation of the Morse decomposition
		*/

		/*  extract the strongly connected components  */
		//L1_morse->dg->find_SCCS();

		//L1_morse->mark_all_valid_SCCS();


		CString str1;
		int loc;
		str1.Format(_T("The graph1 contains %d nodes and %d edges\n"),
			L1_morse->dg->nlist->ndirnodes, L1_morse->dg->elist->nedges);
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str1);

	}

	UpdateData(FALSE);	
	
}

void CIBFVDlg::OnBnClickedButtonl2()
{
	// TODO: Add your control notification handler code here
	CFile f;

	char strFilter[] = { "Directed Graph Files (*.dg)|*.dg|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".dg", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{
		CString f1 = FileDlg.GetPathName();
		CString f2 = FileDlg.GetFileName();
		CString f4 = f2.Right(f2.GetLength()-f2.ReverseFind('.'));
		CString txt = ".dg";
		if(f4!=txt)
		{
			MessageBox("Not a compatible file format, please select a .dg file", "Error");
			return;
		}
		CString f3 = f2.Left(f2.ReverseFind('.'))+".dg";

		const char *filename = f3;

		char str[256];
		strcpy (str, filename);

		L2_morse->load_sub_FG(str);

		/*
		   perform the rest computation of the Morse decomposition
		*/

		/*  extract the strongly connected components  */
		//L2_morse->dg->find_SCCS();

		//L2_morse->mark_all_valid_SCCS();


		CString str1;
		int loc;
		str1.Format(_T("The graph2 contains %d nodes and %d edges\n"),
			L2_morse->dg->nlist->ndirnodes, L2_morse->dg->elist->nedges);
		loc=m_ctrlDebugList.GetCount();
		m_ctrlDebugList.InsertString(loc, str1);

	}

	UpdateData(FALSE);	
}

void CIBFVDlg::OnBnClickedCheckFlipnormal()
{
	// TODO: Add your control notification handler code here

	if (m_chkFlipNormalOn == FALSE)
	{
		m_chkFlipNormalOn = TRUE;
		pclGlView->FlipNormalOn = true;
	}
	else
	{
		m_chkFlipNormalOn = FALSE;
		pclGlView->FlipNormalOn = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckDisableIbfv()
{
	// TODO: Add your control notification handler code here
	if (m_chkIBFVOff == FALSE)
	{
		m_chkIBFVOff = TRUE;
		pclGlView->IBFVOff = true;
	}
	else
	{
		m_chkIBFVOff = FALSE;
		pclGlView->IBFVOff = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedCheckShowrotationsum()
{
	// TODO: Add your control notification handler code here
	if (m_chkShowRotSumOn == FALSE)
	{
		m_chkShowRotSumOn = TRUE;
		ShowRotSumOn = true;
	}
	else
	{
		m_chkShowRotSumOn = FALSE;
		ShowRotSumOn = false;
	}
	UpdateData(FALSE);
}

void CIBFVDlg::OnBnClickedButtonRotationsum()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	//////Recalculate the SCC again
	global_tau = (double)m_edTau;

	if(morse_decomp != NULL)
		delete morse_decomp;
	morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/

	g_start = clock();

	morse_decomp->init_rot_sum();
	morse_decomp->trace_all_Verts_rot_sum(global_tau, 0);
	morse_decomp->trace_all_Verts_rot_sum(global_tau, 1);

	morse_decomp->smooth_A_field();
	//morse_decomp->smooth_A_field();

	morse_decomp->find_out_min_max_rot_sum();

	g_finish = clock();

	CString str;
	int loc;
		str.Format(_T("Finish computing the rotational sum.\n"));
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for this computation is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
	
}

void CIBFVDlg::OnBnClickedButtonOutputtrianglelabels()
{
	// TODO: Add your control notification handler code here

	//output the triangle labels based on the type of Morse set that each triangle belongs to
	FILE *fp = fopen("tri_MS_labels.txt","w");

	for (int i=0; i<object->tlist.ntris; i++)
		fprintf(fp, "%d\n", object->tlist.tris[i]->MS_type);

	fclose(fp);
}

void CIBFVDlg::OnBnClickedButtonSumsmooth()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if(morse_decomp != NULL)
		delete morse_decomp;
	morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/

	g_start = clock();

	for (int i=0; i<1; i++)
	{
		morse_decomp->LIC_like_smoothing();
	}
	morse_decomp->find_out_min_max_rot_sum();

	g_finish = clock();

	CString str;
	int loc;
		str.Format(_T("Finish smoothing the accumulated sum.\n"));
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
		str.Format(_T("time for this computation is %f seconds\n"),(double)(g_finish - g_start)/CLOCKS_PER_SEC);
		loc=g_ctrlDebugList->GetCount();
		g_ctrlDebugList->InsertString(loc, str);
}

void CIBFVDlg::OnBnClickedButtonSaveafield()
{
	// TODO: Add your control notification handler code here
	int i;
	CFile f;

	char strFilter[] = { "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(FALSE, ".txt", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{

		CString f2 = FileDlg.GetFileName();
		const char *filename = f2;

		FILE *fp = fopen(filename, "w");

		/*  output the A field  */
		for(i = 0; i < object->vlist.nverts; i++)
		{
			fprintf(fp, "%f\n", object->vlist.verts[i]->total_rot_sum);
		}

		fclose(fp);

	}
}

void CIBFVDlg::OnBnClickedButtonLoadafield()
{
	// TODO: Add your control notification handler code here
	int i;
	CFile f;

	char strFilter[] = { "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||" };

	CFileDialog FileDlg(TRUE, ".txt", NULL, 0, strFilter);
	if( FileDlg.DoModal() == IDOK )
	{

		CString f2 = FileDlg.GetFileName();
		const char *filename = f2;

		FILE *fp = fopen(filename, "r");
		if(fp == NULL)
		{
			MessageBox("Can not open file!", "Failed!");
			return;
		}

		/*  get the A field  */

		for(i = 0; i < object->vlist.nverts; i++)
		{
			fscanf(fp, "%f\n", &object->vlist.verts[i]->total_rot_sum);
		}

		if(morse_decomp != NULL)
			delete morse_decomp;
		morse_decomp = new MorseDecomp(); /*initialize the Morse Decomposition component*/
	
		morse_decomp->find_out_min_max_rot_sum();

		fclose(fp);

	}
}
