// IBFVDlg.h : header file
//

#pragma once

#include "Traceball.h"

#include "GlView.h"

#include "CGraphView.h"
#include "afxwin.h"
#include "RegionTauMap.h"

// CIBFVDlg dialog
class CIBFVDlg : public CDialog
{
// Construction
public:
	CIBFVDlg(CWnd* pParent = NULL);	// standard constructor
    CGlView *pclGlView;
	CGraphView *pCgraphView;
	
	/*------------------------------------------------*/
	////User interaction
	CTraceBall traceball;
	BOOL m_LeftButtonDown;
	BOOL m_RightButtonDown;
	BOOL m_MiddleButtonDown;

	CPoint m_LeftDownPos;
	Quaternion rvec;
	
	double s_old, t_old;
	double last_x, last_y;
	double s2_old, t2_old;

	CPoint firstwin_leftbottom;
	int firstwin_leftx, firstwin_bottomy, firstwin_rightx, firstwin_topy;

	CPoint secondwin_leftbottom;
	int secondwin_leftx, secondwin_bottomy, secondwin_rightx, secondwin_topy;

// Dialog Data
	enum { IDD = IDD_IBFV2D_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	CString m_edLoadPlyFile;
	afx_msg void OnBnClickedButtonFileborrows();
	CString m_edLoadStreamlineResutls;
	afx_msg void OnBnClickedButtonBorrowstreamlinefile();
	CString m_edSetStreamlinefiletoSave;
	afx_msg void OnBnClickedCheck9Savestreamlineresults();
	BOOL m_chkSaveStreamlineResults;
	BOOL m_chkMoveorNot;
	afx_msg void OnBnClickedCheckAnimatetexture();
	BOOL m_chkDebugOn;
	afx_msg void OnBnClickedCheckDebugon();
	CListBox m_ctrlDebugList;
	BOOL m_chkEnhancedStreamlinePlacementOn;
	afx_msg void OnBnClickedCheckEnhancedmeton();
	BOOL m_chkShowMCG;
	afx_msg void OnBnClickedCheckShowmcgon();
	BOOL m_chkShowMorseSets;
	afx_msg void OnBnClickedCheckShowmorsesets();
	BOOL m_chkShowPeriodicOrbitsOn;
	afx_msg void OnBnClickedCheckShowperiodicorbits();
	BOOL m_chkShowSepsOn;
	afx_msg void OnBnClickedCheckShowseps();
	BOOL m_chkShowFixedPtsOn;
	afx_msg void OnBnClickedCheckShowfixedpts();
	afx_msg void OnBnClickedButtonFixedptdetect();
	afx_msg void OnBnClickedButtonPlacestreamlines();
	afx_msg void OnBnClickedButtonCalseps();
	afx_msg void OnBnClickedButtonExtractperiodicorbits();
	float m_edStreamlinePlace_dsep;
	float m_edStreamlinePlace_slength;
	afx_msg void OnBnClickedButtonMorsedecomp();
	CButton m_ctrlShowMCG;
	CButton m_ctrlShowSep;
	CButton m_ctrlButtonDetectFixedPts;
	CButton m_ctrlButtonCalSeps;
	CButton m_ctrlButtonExtracPOs;
	CButton m_ctrlButtonMorseDecomp;
	CButton m_ctrlButtonBrowsePLYFile;
	CButton m_ctrlEnhancedStreamlinesPlace;
	afx_msg void OnBnClickedButtonSavebmpimg();
	CButton m_ctrlButtonStreamlineLoad;

	void restore_init_state();
	BOOL m_chkColorVFMagOn;
	afx_msg void OnBnClickedCheckShowvfmagnitude();
	float m_edTau;
	afx_msg void OnBnClickedButtonSettau();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
	CStatic m_ctrlOpenGlWin;
	afx_msg void OnBnClickedExrot();
	afx_msg void OnBnClickedInrot();
	int local_morse;
	double local_tau;
	double min_pri;
	double tau_max;
	int iter_max;
	double ini_tau;
	afx_msg void OnEnChangeEdit2();
	afx_msg void OnEnChangeEdit4();
	afx_msg void OnEnChangeEdit5();
	afx_msg void OnEnChangeEdit6();
	afx_msg void OnEnChangeEdit7();
	afx_msg void OnEnChangeEdit8();
	afx_msg void OnBnClickedLocalRefine();
	afx_msg void OnBnClickedAutoRefine();
	RegionTauMap *regiontau;
public:
	CStatic m_ctrlConnectGraphWin;
public:
	BOOL m_chkShowRealMorseID;
public:
	afx_msg void OnBnClickedShowrealid();
	int Morse_Connection;//used to visualize the flow combinatorialization triangles connecting to this morse set, usually the fixed point
	int Triangle_Connection;//used to visualize the flow combinatorialization triangles connecting to this triangle
	afx_msg void OnBnClickedDisplayMorseConnection();
	afx_msg void OnBnClickedDisplayTriangleConnection();
	afx_msg void OnBnClickedDisplayScc();
	afx_msg void OnEnChangeEdit9();
	afx_msg void OnEnChangeEdit10();
	BOOL SampleVis;
	afx_msg void OnBnClickedSampleVis();
public:
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
public:
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
public:
	BOOL m_chkShowTriMappingOn;
public:
	afx_msg void OnBnClickedCheckShowtrimapping();
	afx_msg void OnBnClickedShowbackward();
	BOOL SampleBackward;
	afx_msg void OnBnClickedChangeEdge();
	int sampling_edge;//0,1,2
	BOOL ShowRegion;
	afx_msg void OnBnClickedCheckShowRegion();
	BOOL ShowBoundary;
	afx_msg void OnBnClickedCheckShowboundary();
	BOOL ShowConleyMCG;
	afx_msg void OnBnClickedShowconleymcg();
	BOOL ComputeRegion;
	afx_msg void OnBnClickedCheckComputeConnectionRegion();
public:
	afx_msg void OnBnClickedButtonRefinemcgedge();
public:
	afx_msg void OnBnClickedButtonRefineconnreg();
public:
	afx_msg void OnEnChangeEdit1Morseset1();
public:
	afx_msg void OnEnChangeEditMorseset2();
public:
	int mnode1;
public:
	int mnode2;
public:
	afx_msg void OnEnChangeEditTauvalue();
public:
	double m_edEdgeSampleError;
public:
	afx_msg void OnEnChangeEditSampleerror();
public:
	BOOL m_chkEnFastRefinement;
public:
	afx_msg void OnBnClickedCheckEnfastrefine();
	double Conn_tau;
	afx_msg void OnEnChangeEdit11();
	afx_msg void OnBnClickedButtonOutputdirgraph();
	afx_msg void OnBnClickedButtonLoaddirgraph();
	BOOL m_chkEnConleyIndexComp;
	afx_msg void OnBnClickedCheckEnconleyindexcomp();
public:
	BOOL m_chkRemRedundantMCGEdges;
public:
	afx_msg void OnBnClickedCheckRemoveredundantedges();
public:
	afx_msg void OnBnClickedCheckGreytexture();
public:
	BOOL m_chkEnGreyTexture;
public:
	BOOL m_chkNotShiny;
public:
	afx_msg void OnBnClickedCheckNoshiny();
public:
	BOOL m_chkDisableLighting;
public:
	afx_msg void OnBnClickedCheckDisablelighting();
public:
	BOOL m_chkDisableBackground;
public:
	afx_msg void OnBnClickedCheckDisablebackground();
public:
	BOOL m_chkEnTubeLikeVis;
public:
	afx_msg void OnBnClickedCheckShowtubelike();
public:
	BOOL m_chkShowTDistribution;
public:
	afx_msg void OnBnClickedCheckShowtaudistribution();
	BOOL m_chkShowDiffECGMCG;
	afx_msg void OnBnClickedCheckDisplaydiffecgmcg();
public:
	BOOL m_chkShowMCGDiff;
public:
	afx_msg void OnBnClickedCheckShowdiffmcgs();
	BOOL m_chkNoTMax;
	afx_msg void OnBnClickedCheckAutostop();
public:
	BOOL m_rdIntegrator_opt;
public:
	afx_msg void OnBnClickedRadioEuler1();
public:
	afx_msg void OnBnClickedRadioRk2();
public:
	afx_msg void OnBnClickedRadioRk4();
public:
	BOOL m_chkRemoveDisconnMSOn;
public:
	afx_msg void OnBnClickedCheckRemovedisconn();
public:
	afx_msg void OnBnClickedButtonOutputsubgraph();
public:
	afx_msg void OnBnClickedButtonLoad1();
public:
	afx_msg void OnBnClickedButtonl2();
	BOOL m_chkFlipNormalOn;
	afx_msg void OnBnClickedCheckFlipnormal();
	BOOL m_chkIBFVOff;
	afx_msg void OnBnClickedCheckDisableIbfv();
	BOOL m_chkShowRotSumOn;
	afx_msg void OnBnClickedCheckShowrotationsum();
	afx_msg void OnBnClickedButtonRotationsum();
	afx_msg void OnBnClickedButtonOutputtrianglelabels();
	afx_msg void OnBnClickedButtonSumsmooth();
	afx_msg void OnBnClickedButtonSaveafield();
	afx_msg void OnBnClickedButtonLoadafield();
};
